#<profile4xi profile = "12" />
# =================================================================================================
#<program4xi program = "ball4xi.py">
#<abstract4xi abstract = "offers services of common ball (sphere)"/>
#<refer4xi reference = "DragonXi"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'Ball4Xi',
            'init_ball4xi'
            'set_ball4xi'
            'get_ball4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   
try:
    import _winapi
except:
    pass    
    
from decimal import *
from math import pi
from math import sin
from math import cos
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from print4xi import print4xi
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global Sphere4Xi                                                     #Sphere

global area2ball4xi                                                  #01 area
global color2ball4xi                                                 #02 color
global id2ball4xi                                                    #03 ID
global radius2ball4xi                                                #04 radius
global time2ball4xi                                                  #05 time
global verb2ball4xi                                                  #06 verb
global volume2ball4xi                                                #07 volume
global x2ball4xi                                                     #08 x
global y2ball4xi                                                     #09 y
global z2ball4xi                                                     #10 z
global message2ball4xi                                               #11 message

                                                                     #Shot
global accerelation2shot4xi                                          #01 accerelation
global azimuth2shot4xi                                               #02 azimuth-angle
global color2shot4xi                                                 #03 color
global elevation2shot4xi                                             #04 elevation-angle
global id2shot4xi                                                    #05 ID
global time2shot4xi                                                  #06 time
global velocity2shot4xi                                              #07 velocity
global verb2shot4xi                                                  #08 verb
global x2shot4xi                                                     #09 x
global y2shot4xi                                                     #10 y
global z2shot4xi                                                     #11 z
global distance2shot4xi                                              #12 distance
global message2shot4xi                                               #13 message
global area2shot4xi                                                  #14 area
                                                                      
                                                                     #Measures
global ack2sphere                                                    #01 sphere   
global ack2area                                                      #02 surface area
global ack2volume                                                    #03 volume 
global ack2shot                                                      #04 shot  

global ack2debug
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "

ack2debug = False                                                    # to check with compiler

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Sphere
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                                                                     #11 message
message2ball4xi = 'MainProcess4Xi'
verb2ball4xi = 'skeletonizing'                                       #06 defaul verb and default tense

x2ball4xi = 0                                                        #08 x
y2ball4xi = 0                                                        #09 y
z2ball4xi = 0                                                        #10 z

radius2ball4xi = 1                                                   #04 radius
time2ball4xi = 0                                                     #05 time
color2ball4xi = '#F5E8E8'                                            #02 color

id2ball4xi = str(x2ball4xi) + 'x' + str(y2ball4xi) + 'y' + str(z2ball4xi) + 'z' #03 ID
                                                                     
volume2ball4xi = (4 * pi * radius2ball4xi **3) / 3                   #07 volume

area2ball4xi  = 4 * pi * radius2ball4xi**2                           #01 area



Sphere4Xi = {                                                              # CORE
             id2ball4xi:{ 
                           'area2ball':     area2ball4xi,                  #01 area
                           'color2ball':    color2ball4xi,                 #02 color
                           'radius2ball':   radius2ball4xi,                #04 radius
                           'time2ball':     time2ball4xi,                  #05 time
                           'verb2ball':     verb2ball4xi,                  #06 verb                         
                           'volume2ball':   volume2ball4xi,                #07 volume
                           'x2ball':        x2ball4xi,                     #08 x
                           'y2ball':        y2ball4xi,                     #09 y
                           'z2ball':        z2ball4xi,                     #10 z
                           'message2ball':  message2ball4xi                #11 message
                        }
             } 
if ack2debug is True:
    print(' SPHERE4XI: ', Sphere4Xi)
    
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Shot
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   

accerelation2shot4xi = 0                                                   #01 accerelation for shot
azimuth2shot4xi = 0                                                        #02 azimuth (side) -angle
color2shot4xi = '#F3881C'                                                  #03 color
elevation2shot4xi = 0                                                      #04 elevation (raise) -angle
time2shot4xi = 0                                                           #06 time  
velocity2shot4xi = 0                                                       #07 velocity for shot
verb2shot4xi = 'skeletonizing'                                             #08 verb 

x2shot4xi = int(radius2ball4xi * sin(elevation2shot4xi) * cos(azimuth2shot4xi)) #09 x  
y2shot4xi = int(radius2ball4xi * sin(elevation2shot4xi) * sin(azimuth2shot4xi)) #10 y  
z2shot4xi = int(radius2ball4xi * cos(elevation2shot4xi))                        #11 z  
distance2shot4xi = int(z2shot4xi / cos(elevation2shot4xi))                      #12 distance (= radius2ball4xi for the shot)
message2shot4xi = 'CurrentProcess4Xi'                                           #13 message
area2shot4xi = pi * radius2ball4xi**2                                           #14 area

if ack2debug is True:
    print(' X2SHOT4XI: ', x2shot4xi)
    print(' Y2SHOT4XI: ', y2shot4xi)
    print(' Z2SHOT4XI: ', z2shot4xi)
    print(' DISTANCE2SHOT4XI: ', distance2shot4xi)
              
id2shot4xi = str(x2shot4xi) + 'x' + str(y2shot4xi) + 'y' + str(z2shot4xi) + 'z' 
if id2shot4xi == '0x0y0z':
    id2shot4xi = '0x0y1z'    
if ack2debug is True: 
    print(' ID2SHOT4XI: ', id2shot4xi)
    
Sphere4Xi[id2shot4xi] = {}                                                      # FIRST SHOT WITH DEFAULT VALUES 
Sphere4Xi[id2shot4xi] ['accerelation2shot']   = accerelation2shot4xi            #01 accerelation                                                                     
Sphere4Xi[id2shot4xi] ['azimuth2shot']   = azimuth2shot4xi                      #02 azimuth angle
Sphere4Xi[id2shot4xi] ['color2shot']          = color2shot4xi                   #03 color
Sphere4Xi[id2shot4xi] ['elevation2shot'] = elevation2shot4xi                    #04 elevation-angle    
Sphere4Xi[id2shot4xi] ['time2shot']           = time2shot4xi                    #06 time  
Sphere4Xi[id2shot4xi] ['velocity2shot']       = velocity2shot4xi                #07 velocity   
Sphere4Xi[id2shot4xi] ['verb2shot']           = verb2shot4xi                    #08 verb                    
Sphere4Xi[id2shot4xi] ['x2shot']              = x2shot4xi                       #09 x                           
Sphere4Xi[id2shot4xi] ['y2shot']              = y2shot4xi                       #10 y 
Sphere4Xi[id2shot4xi] ['z2shot']              = z2shot4xi                       #11 z
Sphere4Xi[id2shot4xi] ['distance2shot']       = distance2shot4xi                #12 distance
Sphere4Xi[id2shot4xi] ['message2shot']       =  message2shot4xi                 #13 message
Sphere4Xi[id2shot4xi] ['area2shot']          =  area2shot4xi                    #14 area

if ack2debug is True:
    print(' SPHERE4XI: ', Sphere4Xi)


# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Statistics
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   

ack2sphere = True                                                        
ack2area = True
ack2volume = True            
ack2shot = True
#"
#"/>

 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "init_ball4xi" usage = "
#   initializes ball4xi objects
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
#                  1         2           3              4             5                      6                          7          8
def init_ball4xi(x2ball=0, y2ball=0,  z2ball=0, radius2ball=1, color2ball = '#F5E8E8', verb2ball = 'skeletonize', time2ball=0, message2ball = 'MainProcess4Xi',
#                  9                     10                11                       12                  13              14               15                                                
                 accerelation2shot = 0, azimuth2shot = 0, color2shot = '#F3881C', elevation2shot = 0, time2shot = 0, velocity2shot = 0, verb2shot = 'skeletonizing',
#                 16         17          18                19                                 20                 21 
                 x2shot = 0, y2shot = 0, z2shot = 0, distance2shot = None, message2shot = 'CurrentProcess4Xi', area2shot = 0): 
    '''
    initializes Sphere4Xi
    '''
    
    global Sphere4Xi                                                     #Sphere
    
    global area2ball4xi                                                  #01 area
    global color2ball4xi                                                 #02 color
    global id2ball4xi                                                    #03 ID
    global radius2ball4xi                                                #04 radius
    global time2ball4xi                                                  #05 time
    global verb2ball4xi                                                  #06 verb
    global volume2ball4xi                                                #07 volume
    global x2ball4xi                                                     #08 x
    global y2ball4xi                                                     #09 y
    global z2ball4xi                                                     #10 z
    global message2ball4xi                                               #11 message
    
                                                                         #Shot
    global accerelation2shot4xi                                          #01 accerelation
    global azimuth2shot4xi                                               #02 azimuth-angle
    global color2shot4xi                                                 #03 color
    global elevation2shot4xi                                             #04 elevation-angle
    global id2shot4xi                                                    #05 ID
    global time2shot4xi                                                  #06 time
    global velocity2shot4xi                                              #07 velocity
    global verb2shot4xi                                                  #08 verb
    global x2shot4xi                                                     #09 x
    global y2shot4xi                                                     #10 y
    global z2shot4xi                                                     #11 z
    global distance2shot4xi                                              #12 distance
    global message2shot4xi                                               #13 message
    global area2shot4xi                                                  #14 area 
                                                                             
                                                                         #Measures
    global ack2sphere                                                    #01 sphere   
    global ack2area                                                      #02 surface area
    global ack2volume                                                    #03 volume 
    global ack2shot                                                      #04 shot  
    
    global ack2debug
         
    # -----------------------------------------------------------------------------------------
    # (Step 1/4)           
    # -----------------------------------------------------------------------------------------          
    class2print = "init_ball4xi"
    method2print = "init_ball4xi"

    message2print = "{(Step 1/4a) started" + "; init_ball4xi-started: " + str(init_ball4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 

    # -----------------------------------------------------------------------------------------
    # (Step 1/4)           
    # ----------------------------------------------------------------------------------------- 
    
    # -----------------------------------------------------------------------------------------
    # BALL           
    # ----------------------------------------------------------------------------------------- 
                    
    message2print = "{(Step 1/4b1) passed" + "; x2ball-to-init_ball4xi: " + str(x2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  

    message2print = "{(Step 1/4b2) passed" + "; y2ball-to-init_ball4xi: " + str(y2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    
    message2print = "{(Step 1/4b3) passed" + "; z2ball-to-init_ball4xi: " + str(z2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{(Step 1/4b4) passed" + "; radius2ball-to-init_ball4xi: " + str(radius2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
 
    message2print = "{(Step 1/4b5) passed" + "; color2ball-to-init_ball4xi: " + str(color2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      

    message2print = "{(Step 1/4b6) passed" + "; verb2ball-to-init_ball4xi: " + str(verb2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      

    message2print = "{(Step 1/4b7) passed" + "; time2ball-to-init_ball4xi: " + str(time2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      

    message2print = "{(Step 1/4b8) passed" + "; message2ball-to-init_ball4xi: " + str(message2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    
    # -----------------------------------------------------------------------------------------
    # SHOT           
    # ----------------------------------------------------------------------------------------- 
     
    message2print = "{(Step 1/4b8) passed" + "; accerelation2shot-to-init_ball4xi: " + str(accerelation2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
                     
    message2print = "{(Step 1/4b9) passed" + "; azimuth2shot-to-init_ball4xi: " + str(azimuth2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
                     
    message2print = "{(Step 1/4b10) passed" + "; color2shot-to-init_ball4xi: " + str(color2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
                        
    message2print = "{(Step 1/4b11) passed" + "; elevation2shot-to-init_ball4xi: " + str(elevation2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      

    message2print = "{(Step 1/4b12) passed" + "; time2shot-to-init_ball4xi: " + str(time2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      

    message2print = "{(Step 1/4b13) passed" + "; velocity2shot-to-init_ball4xi: " + str(velocity2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      

    message2print = "{(Step 1/4b14) passed" + "; verb2shot-to-init_ball4xi: " + str(verb2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    
    message2print = "{(Step 1/4b15) passed" + "; x2shot-to-init_ball4xi: " + str(x2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      

    message2print = "{(Step 1/4b16) passed" + "; y2shot-to-init_ball4xi: " + str(y2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      

    message2print = "{(Step 1/4b17) passed" + "; z2shot-to-init_ball4xi: " + str(z2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    
    message2print = "{(Step 1/4b18) passed" + "; distance2shot-to-init_ball4xi: " + str(distance2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      

    message2print = "{(Step 1/4b19) passed" + "; message2shot-to-init_ball4xi: " + str(message2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 

    message2print = "{(Step 1/4b20) passed" + "; area2shot-to-init_ball4xi: " + str(area2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
                                      
    # -----------------------------------------------------------------------------------------
    # (Step 2/4)       
    # -----------------------------------------------------------------------------------------
  
    ack2sphere = False
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # BALL
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
    try:
        x2ball4xi = int(x2ball)
        message2print = "{(Step 2/4a1) initialized" + "; x2ball4xi-initialized-by-init_ball4xi to: " + str(x2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
    except:
        message2print = "{(Step 2/4a1) yielded" + "; x2ball-yielded-by-init_ball4xi: " + str(x2ball)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~        
    try:
        y2ball4xi = int(y2ball)
        message2print = "{(Step 2/4a2) initialized" + "; y2ball4xi-initialized-by-init_ball4xi to: " + str(y2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
    except:
        message2print = "{(Step 2/4a2) yielded" + "; y2ball-yielded-by-init_ball4xi: " + str(y2ball)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
            
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:    
        z2ball4xi = int(z2ball)
        message2print = "{(Step 2/4a3) initialized" + "; z2ball4xi-initialized-by-init_ball4xi to: " + str(z2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
    except:
        message2print = "{(Step 2/4a3) yielded" + "; z2ball-yielded-by-init_ball4xi: " + str(z2ball)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
            
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:
        radius2ball4xi = int(radius2ball)
        message2print = "{(Step 2/4a4) initialized" + "; radius2ball4xi-initialized-by-init_ball4xi to: " + str(radius2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
    except:
        message2print = "{(Step 2/4a4) yielded" + "; radius2ball-yielded-by-init_ball4xi: " + str(radius2ball)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
            
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:
        color2ball4xi = str(color2ball)
        message2print = "{(Step 2/4a5) initialized" + "; color2ball4xi-initialized-by-init_ball4xi to: " + str(color2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # #F5E8E8   

    except:
        message2print = "{(Step 2/4a5) yielded" + "; color2ball-yielded-by-init_ball4xi: " + str(color2ball)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:
        verb2ball4xi = str(verb2ball)
        message2print = "{(Step 2/4a6) initialized" + "; verb2ball4xi-initialized-by-init_ball4xi to: " + str(verb2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   

    except:
        message2print = "{(Step 2/4a6) yielded" + "; verb2ball-yielded-by-init_ball4xi: " + str(verb2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:
        if ((time2ball == 0)  or (time2ball == '0')):
            time2ball4xi = time4xi()
        else:    
            time2ball4xi = str(time2ball)
            
        message2print = "{(Step 2/4a7) initialized" + "; time2ball4xi-initialized-by-init_ball4xi to: " + str(time2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   

    except:
        message2print = "{(Step 2/4a7) yielded" + "; time2ball-yielded-by-init_ball4xi: " + str(time2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # SHOT
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:
        accerelation2shot4xi = accerelation2shot
        message2print = "{(Step 2/4a8) initialized" + "; accerelation2shot4xi-initialized-by-init_ball4xi to: " + str(accerelation2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
    except:
        message2print = "{(Step 2/4a8) yielded" + "; accerelation2shot-yielded-by-init_ball4xi: " + str(accerelation2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:
        azimuth2shot4xi = azimuth2shot
        message2print = "{(Step 2/4a9) initialized" + "; azimuth2shot4xi-initialized-by-init_ball4xi to: " + str(azimuth2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
    except:
        message2print = "{(Step 2/4a9) yielded" + "; azimuth2shot-yielded-by-init_ball4xi: " + str(azimuth2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:
        color2shot4xi = str(color2shot)
        message2print = "{(Step 2/4a10) initialized" + "; color2shot4xi-initialized-by-init_ball4xi to: " + str(color2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    except:
        message2print = "{(Step 2/4a10) yielded" + "; color2shot-yielded-by-init_ball4xi: " + str(color2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:
        elevation2shot4xi = elevation2shot
        message2print = "{(Step 2/4a11) initialized" + "; elevation2shot4xi-initialized-by-init_ball4xi to: " + str(elevation2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    except:
        message2print = "{(Step 2/4a11) yielded" + "; elevation2shot-yielded-by-init_ball4xi: " + str(elevation2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:
        if ((time2shot == 0)  or (time2shot == '0')):
            time2shot4xi = time4xi()
        else:    
            time2shot4xi = str(time2ball)
        message2print = "{(Step 2/4a12) initialized" + "; time2shot4xi-initialized-by-init_ball4xi to: " + str(time2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    except:
        message2print = "{(Step 2/4a12) yielded" + "; time2shot-yielded-by-init_ball4xi: " + str(time2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:
        velocity2shot4xi = velocity2shot
        message2print = "{(Step 2/4a13) initialized" + "; velocity2shot4xi-initialized-by-init_ball4xi to: " + str(velocity2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    except:
        message2print = "{(Step 2/4a13) yielded" + "; velocity2shot-yielded-by-init_ball4xi: " + str(velocity2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:
        verb2shot4xi = str(verb2shot)
        message2print = "{(Step 2/4a14) initialized" + "; verb2shot4xi-initialized-by-init_ball4xi to: " + str(verb2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    except:
        message2print = "{(Step 2/4a14) yielded" + "; verb2shot-yielded-by-init_ball4xi: " + str(verb2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)



    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:
        x2shot4xi = int(x2shot)
        message2print = "{(Step 2/4a15) initialized" + "; x2shot4xi-initialized-by-init_ball4xi to: " + str(x2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    except:
        message2print = "{(Step 2/4a15) yielded" + "; x2shot-yielded-by-init_ball4xi: " + str(x2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:
        y2shot4xi = int(y2shot)
        message2print = "{(Step 2/4a16) initialized" + "; y2shot4xi-initialized-by-init_ball4xi to: " + str(y2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    except:
        message2print = "{(Step 2/4a16) yielded" + "; y2shot-yielded-by-init_ball4xi: " + str(y2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:
        z2shot4xi = int(z2shot)
        message2print = "{(Step 2/4a17) initialized" + "; z2shot4xi-initialized-by-init_ball4xi to: " + str(z2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    except:
        message2print = "{(Step 2/4a17) yielded" + "; z2shot-yielded-by-init_ball4xi: " + str(z2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # distance re-initializes later on x, y and z coordinates
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:
        if distance2shot is None:    
            distance2shot4xi = radius2ball4xi
        else:
            distance2shot4xi = int(distance2shot)    
        
        message2print = "{(Step 2/4a18) initialized" + "; distance2shot4xi-initialized-by-init_ball4xi to: " + str(distance2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    except:
        message2print = "{(Step 2/4a18) yielded" + "; distance2shot-yielded-by-init_ball4xi: " + str(distance2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:
        message2shot4xi = str(message2shot)
        message2print = "{(Step 2/4a19) initialized" + "; message2shot4xi-initialized-by-init_ball4xi to: " + str(message2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    except:
        message2print = "{(Step 2/4a19) yielded" + "; message2shot-yielded-by-init_ball4xi: " + str(message2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:
        if area2shot == 0:
            area2shot4xi = pi * distance2shot4xi **2
        else:
            area2shot4xi = area2shot
        message2print = "{(Step 2/4a20) initialized" + "; area2shot4xi-initialized-by-init_ball4xi to: " + str(area2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    except:
        message2print = "{(Step 2/4a20) yielded" + "; area2shot-yielded-by-init_ball4xi: " + str(area2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                              
    # -----------------------------------------------------------------------------------------
    # BALL CALCULATIONS
    # -----------------------------------------------------------------------------------------  
                                    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # (Step 3/4a) - ID       
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    try:
        id2ball4xi = str(x2ball4xi) + 'x' + str(y2ball4xi) + 'y' + str(z2ball4xi) + 'z'
        
        ack2sphere = True 
    except:
        message2print = "{(Step 3/4a) yielded" + "; id2ball4xi-yielded-by-init_ball4xi: " + str(id2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
                                
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # (Step 3/4b)- VOLUME OF BALL CALCULATION        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
    volume2ball4xi = 0 
    ack2volume = False   
    try:
        volume2ball4xi = (4 * pi * radius2ball4xi **3) / 3
        ack2volume = True
        
    except:
        ack2sphere = False        
        message2print = "{(Step 3/4b) yielded" + "; volume2ball4xi-yielded-by-init_ball4xi: " + str(volume2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # (Step 3/4c) - AREA OF BALL CALCULATION 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    area2ball4xi = 0
    ack2area = False
     
    try:    
        area2ball4xi = 4 * pi * radius2ball4xi**2
        ack2area = True
    except:
        ack2sphere = False 
        message2print = "{(Step 3/4c) yielded" + "; area2ball4xi-yielded-by-init_ball4xi: " + str(area2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # (Step 3/4d) - INITIALIZATION OF BALL WITH CALCULATED VALUES  
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~           
    try:                    

        Sphere4Xi = {}  
        Sphere4Xi[id2ball4xi] = {}  
    except:
        message2print = "{(Step 3/4d0) yielded" + "; Sphere4Xi-yielded-by-init_ball4xi: " + str(Sphere4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2sphere = False
    
    try:                                                                           
        Sphere4Xi[id2ball4xi] ['area2ball']       = area2ball4xi                   #01 area
    except:
        message2print = "{(Step 3/4d1) yielded" + "; area2ball4xi4Xi-yielded-by-init_ball4xi: " + str(area2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2sphere = False
        ack2area = False        
   
    try:    
        Sphere4Xi[id2ball4xi] ['color2ball']      = color2ball4xi                  #02 color
    except:
        message2print = "{(Step 3/4d2) yielded" + "; color2ball4xi4Xi-yielded-by-init_ball4xi: " + str(color2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2sphere = False
   
    try:    
        Sphere4Xi[id2ball4xi] ['id2ball']         = id2ball4xi                     #03 id
    except:
        message2print = "{(Step 3/4d2) yielded" + "; id2ball4xi4Xi-yielded-by-init_ball4xi: " + str(id2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2sphere = False
                                
    try:    
        Sphere4Xi[id2ball4xi] ['radius2ball']     = radius2ball4xi                 #04 radius
    except:
        message2print = "{(Step 3/4d4) yielded" + "; radius2ball4xi4Xi-yielded-by-init_ball4xi: " + str(radius2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2sphere = False
                
    try:    
        Sphere4Xi[id2ball4xi] ['time2ball']       = time2ball4xi                   #05 time
    except:
        message2print = "{(Step 3/4d5) yielded" + "; time2ball4xi4Xi-yielded-by-init_ball4xi: " + str(time2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2sphere = False
                
    try:    
        Sphere4Xi[id2ball4xi] ['verb2ball']       = verb2ball4xi                   #06 verb                         
    except:
        message2print = "{(Step 3/4d6) yielded" + "; verb2ball4xi4Xi-yielded-by-init_ball4xi: " + str(verb2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2sphere = False
                
    try:    
        Sphere4Xi[id2ball4xi] ['volume2ball']     = volume2ball4xi                 #07 volume
    except:
        message2print = "{(Step 3/4d7) yielded" + "; volume2ball4xi4Xi-yielded-by-init_ball4xi: " + str(volume2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2sphere = False
        ack2volume = False        
    try:    
        Sphere4Xi[id2ball4xi] ['x2ball']          = x2ball4xi                      #08 x
    except:
        message2print = "{(Step 3/4d8) yielded" + "; x2ball4xi4Xi-yielded-by-init_ball4xi: " + str(x2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2sphere = False
                
    try:    
        Sphere4Xi[id2ball4xi] ['y2ball']          = y2ball4xi                      #09 y
    except:
        message2print = "{(Step 3/4d9) yielded" + "; y2ball4xi4Xi-yielded-by-init_ball4xi: " + str(y2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2sphere = False
                
    try:    
        Sphere4Xi[id2ball4xi] ['z2ball']          = z2ball4xi                      #10 z
    except:
        message2print = "{(Step 3/4d10) yielded" + "; z2ball4xi 4Xi-yielded-by-init_ball4xi: " + str(z2ball4xi )  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2sphere = False
                
    try:    
        Sphere4Xi[id2ball4xi] ['message2ball']    = message2ball4xi                #11 message
    except:
        message2print = "{(Step 3/4d13) yielded" + "; message2ball4xi 4Xi-yielded-by-init_ball4xi: " + str(message2ball4xi )  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2sphere = False
                        
    message2print = "{(Step 3/4d11) initialized" + "; Sphere4Xi-initialized-by-init_ball4xi to: " + str(Sphere4Xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
                                   

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # SHOT CALCULATIONS
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # (X,Y,Z) CALCULATIONS OF SHOT
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     
             
    try:        
        x2shot4xi = int(distance2shot4xi * sin(elevation2shot4xi) * cos(azimuth2shot4xi)) #09 x  
        y2shot4xi = int(distance2shot4xi * sin(elevation2shot4xi) * sin(azimuth2shot4xi)) #10 y  
        z2shot4xi = int(distance2shot4xi * cos(elevation2shot4xi))                        #11 z  
              
        id2shot4xi = str(x2shot4xi) + 'x' + str(y2shot4xi) + 'y' + str(z2shot4xi) + 'z'
        if id2shot4xi == '0x0y0z':
            id2shot4xi = '0x0y1z'   
    except:
        message2print = "{(Step 3/4e5) yielded" + "; id2shot4xi-yielded-by-init_ball4xi: " + str(id2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        ack2shot = False
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # AREA CALCULATION OF SHOT, IF REQUIRED
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     
    try:
        if ((area2shot is None) or (area2shot == 0)):
            area2shot4xi = pi * distance2shot4xi**2 
        else:
            area2shot4xi = area2shot  
    except:
        message2print = "{(Step 3/4e14) yielded" + "; area2shot4xi-yielded-by-init_ball4xi: " + str(area2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        ack2shot = False

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # SHOT INITIALIZATION WITH CALCULATED VALUES
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
                    
    try:        
        Sphere4Xi[id2shot4xi] = {} 
    except:
        message2print = "{(Step 3/4e0) yielded" + "; Sphere4Xi-yielded-by-init_ball4xi: " + str(Sphere4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2shot = False        
    
    try:
        Sphere4Xi[id2shot4xi] ['accerelation2shot']   = accerelation2shot4xi            #01 accerelation  
    except:
        message2print = "{(Step 3/4e1) yielded" + "; accerelation2shot4xi-yielded-by-init_ball4xi: " + str(accerelation2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2shot = False                                                                                   
    
    try:
        Sphere4Xi[id2shot4xi] ['azimuth2shot']   = azimuth2shot4xi                      #02 azimuth angle
    except:
        message2print = "{(Step 3/4e2) yielded" + "; azimuth2shot4xi-yielded-by-init_ball4xi: " + str(azimuth2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2shot = False        
    
    try:
        Sphere4Xi[id2shot4xi] ['color2shot']          = color2shot4xi                   #03 color
    except:
        message2print = "{(Step 3/4e3) yielded" + "; color2shot4xi-yielded-by-init_ball4xi: " + str(color2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2shot = False        
    
    try:
        Sphere4Xi[id2shot4xi] ['elevation2shot'] = elevation2shot4xi                    #04 elevation-angle    
    except:
        message2print = "{(Step 3/4e4) yielded" + "; elevation2shot4xi-yielded-by-init_ball4xi: " + str(elevation2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2shot = False        
    
    try:
        Sphere4Xi[id2shot4xi] ['id2shot'] = id2shot4xi                                  #05 ID    
    except:
        message2print = "{(Step 3/4e5) yielded" + "; id2shot4xi-yielded-by-init_ball4xi: " + str(id2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2shot = False        
        
    try:
        Sphere4Xi[id2shot4xi] ['time2shot']           = time2shot4xi                    #06 time  
    except:
        message2print = "{(Step 3/4e6) yielded" + "; time2shot4xi-yielded-by-init_ball4xi: " + str(time2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2shot = False        
    
    try:
        Sphere4Xi[id2shot4xi] ['velocity2shot']       = velocity2shot4xi                #07 velocity   
    except:
        message2print = "{(Step 3/4e7) yielded" + "; velocity2shot4xi-yielded-by-init_ball4xi: " + str(velocity2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2shot = False        
    
    try:
        Sphere4Xi[id2shot4xi] ['verb2shot']           = verb2shot4xi                    #08 verb                    
    except:
        message2print = "{(Step 3/4e8) yielded" + "; verb2shot4xi-yielded-by-init_ball4xi: " + str(verb2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2shot = False        
    
    try:
        Sphere4Xi[id2shot4xi] ['x2shot']              = x2shot4xi                       #09 x                           
    except:
        message2print = "{(Step 3/4e9) yielded" + "; x2shot4xi-yielded-by-init_ball4xi: " + str(x2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2shot = False        
    
    try:
        Sphere4Xi[id2shot4xi] ['y2shot']              = y2shot4xi                       #10 y 
    except:
        message2print = "{(Step 3/4e10) yielded" + "; y2shot4xi-yielded-by-init_ball4xi: " + str(y2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2shot = False        
    
    try:
        Sphere4Xi[id2shot4xi] ['z2shot']              = z2shot4xi                       #11 z
    except:
        message2print = "{(Step 3/4e11) yielded" + "; z2shot4xi-yielded-by-init_ball4xi: " + str(z2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2shot = False        
    
    try:
        distance2shot4xi = int(z2shot4xi / cos(elevation2shot4xi))                      
        if distance2shot4xi == 0:
            distance2shot4xi = 1
        Sphere4Xi[id2shot4xi] ['distance2shot']       = distance2shot4xi                #12 distance (again)
    except:
        message2print = "{(Step 3/4e12) yielded" + "; distance2shot4xi-yielded-by-init_ball4xi: " + str(distance2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2shot = False           
    
    try:
        Sphere4Xi[id2shot4xi] ['message2shot']        = message2shot4xi                 #13 message
    except:
        message2print = "{(Step 3/4e13) yielded" + "; message2shot4xi-yielded-by-init_ball4xi: " + str(message2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2shot = False        

    try:
        Sphere4Xi[id2shot4xi] ['area2shot']           = area2shot4xi                    #14 area
    except:
        message2print = "{(Step 3/4e14) yielded" + "; area2shot4xi-yielded-by-init_ball4xi: " + str(area2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2shot = False        
                    
    message2print = "{(Step 3/4e17) initialized" + "; Sphere4Xi-initialized-by-init_ball4xi to: " + str(Sphere4Xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                           


    
        
    # -----------------------------------------------------------------------------------------
    # (Step 4/4)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 4/4) returning" + "; init_ball4xi-returning: "  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
        
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set_ball4xi" usage = "
#   sets ball4xi objects
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
#                  1                2               3                4                  5                  6                7               8
def set_ball4xi(x2ball = None,y2ball = None, z2ball = None, radius2ball = None, color2ball = None, verb2ball = None, time2ball = None, message2ball = 'MainProcess4Xi',

#                  9                          10                  11                  12                  13                 14                    15       
                accerelation2shot = None, azimuth2shot = None, color2shot = None, elevation2shot = None, time2shot = None, velocity2shot = None, verb2shot = None, 
#                 16             17               18               19                   20                               21
                x2shot = None, y2shot = None, z2shot = None, distance2shot = None, message2shot = 'CurrentProcess4Xi', area2shot = None):

    '''
    sets Sphere4Xi
    '''
    
    
    global Sphere4Xi                                                     #Sphere
    
    global area2ball4xi                                                  #01 area
    global color2ball4xi                                                 #02 color
    global id2ball4xi                                                    #03 ID
    global radius2ball4xi                                                #04 radius
    global time2ball4xi                                                  #05 time
    global verb2ball4xi                                                  #06 verb
    global volume2ball4xi                                                #07 volume
    global x2ball4xi                                                     #08 x
    global y2ball4xi                                                     #09 y
    global z2ball4xi                                                     #10 z
    global message2ball4xi                                               #11 message
    
                                                                         #Shot
    global accerelation2shot4xi                                          #01 accerelation
    global azimuth2shot4xi                                               #02 azimuth-angle
    global color2shot4xi                                                 #03 color
    global elevation2shot4xi                                             #04 elevation-angle
    global id2shot4xi                                                    #05 ID
    global time2shot4xi                                                  #06 time
    global velocity2shot4xi                                              #07 velocity
    global verb2shot4xi                                                  #08 verb
    global x2shot4xi                                                     #09 x
    global y2shot4xi                                                     #10 y
    global z2shot4xi                                                     #11 z
    global distance2shot4xi                                              #12 distance
    global message2shot4xi                                               #13 message
    global area2shot4xi                                                  #14 area 
                                                                                      
                                                                         #Measures
    global ack2sphere                                                    #01 sphere   
    global ack2area                                                      #02 surface area
    global ack2volume                                                    #03 volume 
    global ack2shot                                                      #04 shot  
    
    global ack2debug
           
                  
    # -----------------------------------------------------------------------------------------
    # (Step 1/4)           
    # -----------------------------------------------------------------------------------------          
    class2print = "set_ball4xi"
    method2print = "set_ball4xi"

    message2print = "{(Step 1/4a) started" + "; set_ball4xi-started: " + str(set_ball4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    
    # -----------------------------------------------------------------------------------------
    # BALL          
    # -----------------------------------------------------------------------------------------
             
    message2print = "{(Step 1/4b1) passed" + "; x2ball-to-set_ball4xi: " + str(x2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{(Step 1/4b2) passed" + "; y2ball-to-set_ball4xi: " + str(y2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    
    message2print = "{(Step 1/4b3) passed" + "; z2ball-to-set_ball4xi: " + str(z2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         
    
    message2print = "{(Step 1/4b4) passed" + "; radius2ball-to-set_ball4xi: " + str(radius2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      

    message2print = "{(Step 1/4b5) passed" + "; color2ball-to-set_ball4xi: " + str(color2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         

    message2print = "{(Step 1/4b6) passed" + "; verb2ball-to-set_ball4xi: " + str(verb2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         

    message2print = "{(Step 1/4b7) passed" + "; time2ball-to-set_ball4xi: " + str(time2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         

    message2print = "{(Step 1/4b8) passed" + "; message2ball-to-set_ball4xi: " + str(message2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         
      
        
    # -----------------------------------------------------------------------------------------
    # SHOT           
    # -----------------------------------------------------------------------------------------
      
    message2print = "{(Step 1/4b9) passed" + "; accerelation2shot-to-set_ball4xi: " + str(accerelation2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         

    message2print = "{(Step 1/4b10) passed" + "; azimuth2shot-to-set_ball4xi: " + str(azimuth2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         

    message2print = "{(Step 1/4b11) passed" + "; color2shot-to-set_ball4xi: " + str(color2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         

    message2print = "{(Step 1/4b12) passed" + "; elevation2shot-to-set_ball4xi: " + str(elevation2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         

    message2print = "{(Step 1/4b13) passed" + "; time2shot-to-set_ball4xi: " + str(time2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         

    message2print = "{(Step 1/4b14) passed" + "; velocity2shot-to-set_ball4xi: " + str(velocity2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         

    message2print = "{(Step 1/4b15) passed" + "; verb2shot-to-set_ball4xi: " + str(verb2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         

    message2print = "{(Step 1/4b16) passed" + "; x2shot-to-set_ball4xi: " + str(x2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         

    message2print = "{(Step 1/4b17) passed" + "; y2shot-to-set_ball4xi: " + str(y2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         

    message2print = "{(Step 1/4b18) passed" + "; z2shot-to-set_ball4xi: " + str(z2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         
    
    message2print = "{(Step 1/4b19) passed" + "; distance2shot-to-set_ball4xi: " + str(distance2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    
    message2print = "{(Step 1/4b20) passed" + "; message2shot-to-set_ball4xi: " + str(message2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    
    message2print = "{(Step 1/4b21) passed" + "; area2shot-to-set_ball4xi: " + str(area2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
                                                       
    # -----------------------------------------------------------------------------------------
    # SET ONLY THE REQUIRED VALUES FOR SPHERE AND KEEP OTHERS      
    # -----------------------------------------------------------------------------------------                  

    message2print = "{(Step 2/4) informing" + "; setting-informing-by-set_ball4xi: " + str('setting new values for spehere') + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
         
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # BALL SETTINGS
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~      
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 08
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:
        if x2ball:
            x2ball4xi = int(x2ball)
    except:
        message2print = "{(Step 2/4a8) yielded" + "; x2ball4xi-yielded-by-set_ball4xi: " + str(x2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 09
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:    
        if y2ball:
            y2ball4xi = int(y2ball)
    except:
        message2print = "{(Step 2/4a9) yielded" + "; y2ball4xi-yielded-by-set_ball4xi: " + str(y2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 10
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:                
        if z2ball:
            z2ball4xi = int(z2ball)
    except:
        message2print = "{(Step 2/4a10) yielded" + "; z2ball4xi-yielded-by-set_ball4xi: " + str(z2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 04
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:                
        if radius2ball:
            radius2ball4xi = int(radius2ball)
    except:
        message2print = "{(Step 2/4a4) yielded" + "; radius2ball4xi-yielded-by-set_ball4xi: " + str(radius2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 02
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:                
        if color2ball:
            color2ball4xi = str(color2ball)    
    except:
        message2print = "{(Step 2/4a2) yielded" + "; color2ball4xi-yielded-by-set_ball4xi: " + str(color2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 06
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:                
        if verb2ball:
            verb2ball4xi = str(verb2ball)    
    except:
        message2print = "{(Step 2/4a6) yielded" + "; verb2ball4xi-yielded-by-set_ball4xi: " + str(verb2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 

        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 05
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:                
        if time2ball:
            time2ball4xi = str(time2ball)    
    except:
        message2print = "{(Step 2/4a5) yielded" + "; time2ball4xi-yielded-by-set_ball4xi: " + str(time2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 

        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 11
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:                
        if message2ball:
            message2ball4xi = str(message2ball)    
    except:
        message2print = "{(Step 2/4a11) yielded" + "; message2ball4xi-yielded-by-set_ball4xi: " + str(message2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                                                   
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # SHOT SETTINGS
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       

    message2print = "{(Step 2/4b) informing" + "; setting-informing-by-set_ball4xi: " + str('setting new values for shot') + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
         
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 01
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:                
        if accerelation2shot:
            accerelation2shot4xi = accerelation2shot    
    except:
        message2print = "{(Step 2/4b1) yielded" + "; accerelation2shot-yielded-by-set_ball4xi: " + str(accerelation2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                         
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 02
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:                
        if azimuth2shot:
            azimuth2shot4xi = azimuth2shot
    except:
        message2print = "{(Step 2/4b2) yielded" + "; azimuth2shot-yielded-by-set_ball4xi: " + str(azimuth2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                         
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 03
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:                
        if color2shot:
            color2shot4xi = str(color2shot)    
    except:
        message2print = "{(Step 2/4b3) yielded" + "; color2shot-yielded-by-set_ball4xi: " + str(color2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                         
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 04
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:                
        if elevation2shot:
            elevation2shot4xi = elevation2shot    
    except:
        message2print = "{(Step 2/4b4) yielded" + "; elevation2shot-yielded-by-set_ball4xi: " + str(elevation2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                         
                                                             
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 06
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:                
        if time2shot:
            time2shot4xi = time2shot    
    except:
        message2print = "{(Step 2/4b6) yielded" + "; time2shot-yielded-by-set_ball4xi: " + str(time2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                         
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 07
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:                
        if velocity2shot:
            velocity2shot4xi = velocity2shot    
    except:
        message2print = "{(Step 2/4b7) yielded" + "; velocity2shot-yielded-by-set_ball4xi: " + str(velocity2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                         
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 08
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:                
        if verb2shot:
            verb2shot4xi = str(verb2shot)    
    except:
        message2print = "{(Step 2/4b8) yielded" + "; verb2shot-yielded-by-set_ball4xi: " + str(verb2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                         
                
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 09
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:                
        if x2shot:
            x2shot4xi = int(x2shot)
    except:
        message2print = "{(Step 2/4b9) yielded" + "; x2shot-yielded-by-set_ball4xi: " + str(x2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                         
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 10
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:                
        if y2shot:
            y2shot4xi = int(y2shot)
    except:
        message2print = "{(Step 2/4b10) yielded" + "; y2shot-yielded-by-set_ball4xi: " + str(y2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                         
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 11
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:                
        if z2shot:
            z2shot4xi = int(z2shot)
    except:
        message2print = "{(Step 2/4b11) yielded" + "; z2shot-yielded-by-set_ball4xi: " + str(z2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 

              
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 12
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:
        if distance2shot:
            distance2shot4xi = int(distance2shot)                

            message2print = "{(Step 2/4b12a) using" + "; distance2shot-using-by-set_ball4xi: " + str(distance2shot)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  

            area2shot4xi = pi * distance2shot4xi**2

            message2print = "{(Step 2/4b12b) calculated" + "; area2shot-calculated-by-set_ball4xi: " + str(area2shot)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            
    except:
        message2print = "{(Step 2/4b12c) yielded" + "; distance2shot-yielded-by-set_ball4xi: " + str(distance2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 13
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:                
        if message2shot:
            message2shot4xi = str(message2shot)
    except:
        message2print = "{(Step 2/4b13) yielded" + "; message2shot-yielded-by-set_ball4xi: " + str(message2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 14
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:
        if area2shot:
            area2shot4xi = area2shot
    except:
        message2print = "{(Step 2/4b14) yielded" + "; area2shot-yielded-by-set_ball4xi: " + str(area2shot)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                                             
                                 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # (Step 3/4) - CALCULATE NEW VALUES
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       

    message2print = "{(Step 3/4) informing" + "; calculation-informing-by-set_ball4xi: " + str('calculating new values for sphere') + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
         
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ID OF SPHERE UPDATE
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
    try:            
        id2ball4xi = str(x2ball4xi) + 'x' + str(z2ball4xi) + 'y' + str(z2ball4xi) + 'z'
    except:    
        message2print = "{(Step 3/4a3) yielded" + "; id2ball4xi-yielded-by-set_ball4xi: " + str(id2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
         
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # VOLUME OF SPHERE UPDATE
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:            
        volume2ball4xi = (4 * pi * radius2ball4xi **3) / 3
    except:    
        message2print = "{(Step 3/4a7) yielded" + "; volume2ball4xi-yielded-by-set_ball4xi: " + str(volume2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # AREA OF SPHERE UPDATE
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
    try:        
        area2ball4xi = 4 * pi * radius2ball4xi**2        
    except:    
        message2print = "{(Step 3/4a1) yielded" + "; area2ball4xi-yielded-by-set_ball4xi: " + str(area2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
         
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # USE NEW VALUES FOR SPHERE
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~           
    message2print = "{(Step 3/4a0a) using" + "; Sphere4Xi-using-by-set_ball4xi: " + str(Sphere4Xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    

    # {'0x0y1z': {'time2shot': 0, 'accerelation2shot': 0, 'x2shot': 0, 'azimuth2shot': 0, 'velocity2shot': 0, 'verb2shot': 'skeletonizing', 'y2shot': 0, 'z2shot': 1, 'elevation2shot': 0, 'color2shot': 0}, 
    #  '0x0y0z': {'radius2ball': 1, 'x2ball': 0, 'z2ball': 0, 'area2ball': 12.566370614359172, 'color2ball': '#F5E8E8', 'y2ball': 0, 'id2ball': '0x0y0z', 'verb2ball': 'skeletonize', 'time2ball': 0, 'volume2ball': 4.1887902047863905}}; time: 03:02:45 05/21/10 Pacific Daylight Time}
 
    message2print = "{(Step 3/4a0b) using" + "; id2ball4xi-using-by-set_ball4xi: " + str(id2ball4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    # 100x300y300z
    
    if id2ball4xi == '0x0y0z':                                                     # updates while setting again the ones with no changes
        pass
    else:
        Sphere4Xi[id2ball4xi] = {}                                                 # new ball
        
    try:                    
        Sphere4Xi[id2ball4xi] ['area2ball']       = area2ball4xi                   #01 area
    except:
        message2print = "{(Step 3/4b1) yielded" + "; area2ball4xi-yielded-by-set_ball4xi: " + str(area2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2sphere = False
        ack2area = False
    try:            
        Sphere4Xi[id2ball4xi] ['color2ball']      = color2ball4xi                  #02 color
    except:
        message2print = "{(Step 3/4b2) yielded" + "; color2ball4xi-yielded-by-set_ball4xi: " + str(color2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2sphere = False
    try:            
        Sphere4Xi[id2ball4xi] ['id2ball']      = id2ball4xi                        #03 id
    except:
        message2print = "{(Step 3/4b3) yielded" + "; id2ball4xi-yielded-by-set_ball4xi: " + str(id2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        ack2sphere = False                      
    try:    
        Sphere4Xi[id2ball4xi] ['radius2ball']     = radius2ball4xi                 #04 radius
    except:    
        message2print = "{(Step 3/4b4) yielded" + "; radius2ball4xi-yielded-by-set_ball4xi: " + str(radius2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2sphere = False           
    try:    
        Sphere4Xi[id2ball4xi] ['time2ball']       = time2ball4xi                   #05 time
    except:    
        message2print = "{(Step 3/4b5) yielded" + "; time2ball4xi-yielded-by-set_ball4xi: " + str(time2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2sphere = False             
    try:    
        Sphere4Xi[id2ball4xi] ['verb2ball']       = verb2ball4xi                   #06 verb 
    except:    
        message2print = "{(Step 3/4b6) yielded" + "; verb2ball4xi-yielded-by-set_ball4xi: " + str(verb2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2sphere = False                                     
    try:    
        Sphere4Xi[id2ball4xi] ['volume2ball']     = volume2ball4xi                 #07 volume
        ack2sphere = False
        ack2volume = False
    except:    
        message2print = "{(Step 3/4b7) yielded" + "; volume2ball4xi-yielded-by-set_ball4xi: " + str(volume2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        ack2sphere = False             
    try:    
        Sphere4Xi[id2ball4xi] ['x2ball']    = x2ball4xi                            #08 x
    except:    
        message2print = "{(Step 3/4b8) yielded" + "; x2ball4xi-yielded-by-set_ball4xi: " + str(x2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        ack2sphere = False            
    try:    
        Sphere4Xi[id2ball4xi] ['y2ball']    = y2ball4xi                             #09 y
        ack2sphere = False
    except:    
        message2print = "{(Step 3/4b9) yielded" + "; y2ball4xi-yielded-by-set_ball4xi: " + str(y2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
    try:    
        Sphere4Xi[id2ball4xi] ['z2ball']    = z2ball4xi                             #10 z
        ack2sphere = False
    except:    
        message2print = "{(Step 3/4b10) yielded" + "; z2ball4xi-yielded-by-set_ball4xi: " + str(z2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
    try:    
        Sphere4Xi[id2ball4xi] ['message2ball'] = message2ball4xi                    #11 message
        ack2sphere = False
    except:    
        message2print = "{(Step 3/4b11) yielded" + "; message2ball4xi-yielded-by-set_ball4xi: " + str(message2ball4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
         
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # (Step 3/4c) - CALCULATE NEW VALUES FOR SHOT 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~          

    message2print = "{(Step 3/4c) informing" + "; calculation-informing-by-set_ball4xi: " + str('calculating new values for shot') + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
         
    
    try: 
        message2print = "{(Step 3/4c12) used" + "; distance2shot4xi-used-by-set_ball4xi: " + str(distance2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        # 1 
        
        message2print = "{(Step 3/4c4) used" + "; elevation2shot4xi-used-by-set_ball4xi: " + str(elevation2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 0.785398163397
        
        message2print = "{(Step 3/4c2) used" + "; azimuth2shot4xi-used-by-set_ball4xi: " + str(azimuth2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 1.57079632679
        
        message2print = "{(Step 3/4ca) used" + "; sin-elevation2shot4xi-used-by-set_ball4xi: " + str(sin(elevation2shot4xi))  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # 0.707106781187
        
        message2print = "{(Step 3/4cb) used" + "; cos-azimuth2shot4xi-used-by-set_ball4xi: " + str(cos(azimuth2shot4xi))  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # 6.12323399574e-17
                                   
        x2shot4xi = distance2shot4xi * sin(elevation2shot4xi) * cos(azimuth2shot4xi) #09 x  

        message2print = "{(Step 3/4c9a) used" + "; x2shot4xi-float-used-by-set_ball4xi: " + str(x2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 4.32978028118e-17
        
        x2shot4xi = int(x2shot4xi)
        
        message2print = "{(Step 3/4c9) upgraded" + "; x2shot4xi-upgraded-by-set_ball4xi: " + str(x2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 0

                
        y2shot4xi = distance2shot4xi * sin(elevation2shot4xi) * sin(azimuth2shot4xi) #10 y  
  
        message2print = "{(Step 3/4c10a) used" + "; sin-elevation2shot4xi-used-by-set_ball4xi: " + str(sin(elevation2shot4xi))  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
        
        message2print = "{(Step 3/4c10b) used" + "; y2shot4xi-float-used-by-set_ball4xi: " + str(y2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        
        
        y2shot4xi = int(y2shot4xi)
        
        message2print = "{(Step 3/4c10) upgraded" + "; y2shot4xi-upgraded-by-set_ball4xi: " + str(y2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 0      
        
        z2shot4xi = distance2shot4xi * cos(elevation2shot4xi)                         #11 z  
        
        message2print = "{(Step 3/4c11a) used" + "; cos-elevation2shot4xi-used-by-set_ball4xi: " + str(cos(elevation2shot4xi))  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)              

        message2print = "{(Step 3/4c11b) used" + "; z2shot4xi-float-used-by-set_ball4xi: " + str(z2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        
        z2shot4xi = int(z2shot4xi)
                        
        message2print = "{(Step 3/4c11) upgraded" + "; z2shot4xi-upgraded-by-set_ball4xi: " + str(z2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 0  
                   
        id2shot4xi = str(x2shot4xi) + 'x' + str(y2shot4xi) + 'y' + str(z2shot4xi) + 'z' 
        
        if id2shot4xi == '0x0y0z':
            id2shot4xi = '0x0y1z'                                                   # with radius 1 shot might end to origin !
        
            message2print = "{(Step 3/4c5a) upgraded" + "; id2shot4xi-upgraded-by-set_ball4xi: " + str(id2shot4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)     
            ack2shot = False            
        
        message2print = "{(Step 3/4c5) upgraded" + "; id2shot4xi-upgraded-by-set_ball4xi: " + str(id2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #   

          
    except:
        message2print = "{(Step 3/4d) yielded" + "; id2shot4xi-yielded-by-set_ball4xi: " + str(id2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        ack2shot = False

    message2print = "{(Step 3/4e) informing" + "; calculation-informing-by-set_ball4xi: " + str('calculated new values for shot') + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
            
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # USE NEW VALUES TO CREATE A NEW SHOT 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~        
    message2print = "{(Step 3/4f1) informing" + "; using-informing-by-set_ball4xi: " + str('using new values for new shot') + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
  
    message2print = "{(Step 3/4f2) using" + "; id2shot4xi-using-by-set_ball4xi: " + str(id2shot4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    
    if id2shot4xi == '0x0y0z':
        id2shot4xi = '0x0y1z'
        message2print = "{(Step 3/4f3) yielded" + "; id2shot4xi-yielded-by-init_ball4xi: " + str(id2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        ack2shot = False
  
    message2print = "{(Step 3/4f4) using" + "; id2shot4xi-using-by-set_ball4xi: " + str(id2shot4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
               
    try:        
        Sphere4Xi[id2shot4xi] = {}
    except:
        message2print = "{(Step 3/4f5) yielded" + "; Sphere4Xi-yielded-by-init_ball4xi: " + str(Sphere4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        ack2shot = False
  
    message2print = "{(Step 3/4f6) using" + "; accerelation2shot4xi-using-by-set_ball4xi: " + str(accerelation2shot4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
                
    try:         
        Sphere4Xi[id2shot4xi] ['accerelation2shot']   = accerelation2shot4xi            #01 accerelation 
    except:
        message2print = "{(Step 3/4f7) yielded" + "; accerelation2shot4xi-yielded-by-init_ball4xi: " + str(accerelation2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        ack2shot = False
  
    message2print = "{(Step 3/4f8) using" + "; azimuth2shot4xi-using-by-set_ball4xi: " + str(azimuth2shot4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
               
    try:                                                                          
        Sphere4Xi[id2shot4xi] ['azimuth2shot']   = azimuth2shot4xi                       #02 azimuth angle
    except:
        message2print = "{(Step 3/4f9) yielded" + "; azimuth2shot4xi-yielded-by-init_ball4xi: " + str(azimuth2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        ack2shot = False
  
    message2print = "{(Step 3/4f10) using" + "; color2shot4xi-using-by-set_ball4xi: " + str(color2shot4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
               
    try:      
        Sphere4Xi[id2shot4xi] ['color2shot']          = color2shot4xi                   #03 color
    except:
        message2print = "{(Step 3/4f11) yielded" + "; color2shot4xi-yielded-by-init_ball4xi: " + str(color2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        ack2shot = False
  
    message2print = "{(Step 3/4f12) using" + "; elevation2shot4xi-using-by-set_ball4xi: " + str(elevation2shot4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
              
    try:      
        Sphere4Xi[id2shot4xi] ['elevation2shot'] = elevation2shot4xi                     #04 elevation-angle 
    except:
        message2print = "{(Step 3/4f13) yielded" + "; elevation2shot4xi-yielded-by-init_ball4xi: " + str(elevation2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        ack2shot = False
  
    message2print = "{(Step 3/4f14) using" + "; time2shot4xi-using-by-set_ball4xi: " + str(time2shot4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
              
    try:         
        Sphere4Xi[id2shot4xi] ['time2shot']           = time2shot4xi                    #06 time
    except:
        message2print = "{(Step 3/4f15) yielded" + "; time2shot4xi-yielded-by-init_ball4xi: " + str(time2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        ack2shot = False
  
    message2print = "{(Step 3/4f16) using" + "; velocity2shot4xi-using-by-set_ball4xi: " + str(velocity2shot4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
                
    try:        
        Sphere4Xi[id2shot4xi] ['velocity2shot']       = velocity2shot4xi                #07 velocity 
    except:
        message2print = "{(Step 3/4f17) yielded" + "; velocity2shot4xi-yielded-by-init_ball4xi: " + str(velocity2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        ack2shot = False
  
    message2print = "{(Step 3/4f18) using" + "; verb2shot4xi-using-by-set_ball4xi: " + str(verb2shot4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
             
    try:        
        Sphere4Xi[id2shot4xi] ['verb2shot']           = verb2shot4xi                    #08 verb
    except:
        message2print = "{(Step 3/4f19) yielded" + "; verb2shot4xi-yielded-by-init_ball4xi: " + str(verb2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        ack2shot = False
  
    message2print = "{(Step 3/4f20) using" + "; x2shot4xi-using-by-set_ball4xi: " + str(x2shot4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
                
    try:                          
        Sphere4Xi[id2shot4xi] ['x2shot']              = x2shot4xi                       #09 x 
    except:
        message2print = "{(Step 3/4f21) yielded" + "; x2shot4xi-yielded-by-init_ball4xi: " + str(x2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        ack2shot = False
  
    message2print = "{(Step 3/4f22) using" + "; y2shot4xi-using-by-set_ball4xi: " + str(y2shot4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
                     
    try:                                
        Sphere4Xi[id2shot4xi] ['y2shot']              = y2shot4xi                       #10 y 
    except:
        message2print = "{(Step 3/4f23) yielded" + "; y2shot4xi-yielded-by-init_ball4xi: " + str(y2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        ack2shot = False
  
    message2print = "{(Step 3/4f24) using" + "; z2shot4xi-using-by-set_ball4xi: " + str(z2shot4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
                     
    try:      
        Sphere4Xi[id2shot4xi] ['z2shot']              = z2shot4xi                       #11 z
            
    except:
        message2print = "{(Step 3/4f25) yielded" + "; z2shot4xi-yielded-by-init_ball4xi: " + str(z2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        ack2shot = False
  
    message2print = "{(Step 3/4f26) using" + "; distance2shot4xi-using-by-set_ball4xi: " + str(distance2shot4xi)  + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)    
                    
    try:      
        Sphere4Xi[id2shot4xi] ['distance2shot'] = distance2shot4xi                      #12 distance
            
    except:
        message2print = "{(Step 3/4f27) yielded" + "; distance2shot4xi-yielded-by-init_ball4xi: " + str(distance2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        ack2shot = False
  
    message2print = "{(Step 3/4f28) using" + "; message2shot4xi-using-by-set_ball4xi: " + str(message2shot4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
                   
    try:      
        Sphere4Xi[id2shot4xi] ['message2shot'] = message2shot4xi                        #13 message
            
    except:
        message2print = "{(Step 3/4f29) yielded" + "; message2shot4xi-yielded-by-init_ball4xi: " + str(message2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        ack2shot = False
                   
    try:      
        Sphere4Xi[id2shot4xi] ['area2shot'] = area2shot4xi                              #14 area
            
    except:
        message2print = "{(Step 3/4f30) yielded" + "; area2shot4xi-yielded-by-init_ball4xi: " + str(area2shot4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        ack2shot = False
                                                     
    message2print = "{(Step 3/4g) set" + "; Sphere4Xi-set-by-set_ball4xi to: " + str(Sphere4Xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         
          
    # -----------------------------------------------------------------------------------------
    # (Step 4/4)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 4/4) returning" + "; set_ball4xi-returning: "  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
        
#</function4xi>


 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get_ball4xi" usage = "
#   gets ball4xi object attributes
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
#                    1            2                 3               4                5                  6                  7                 8              9      10       11
def get_ball4xi(area2ball=None, color2ball=None, id2ball=None, radius2ball=None, time2ball = None, verb2ball=None, volume2ball=None, x2ball=None,y2ball=None,z2ball=None, message2ball = None,  
#                  1                         2                  3                    4                    5                 6                 7                      8                             
 
                accerelation2shot = None, azimuth2shot = None, color2shot = None, elevation2shot = None, id2shot = None, time2shot = None, velocity2shot = None, verb2shot = None, 
#                  9              10             11             12                       13                 14
                
                x2shot = None, y2shot = None, z2shot = None, distance2shot = None, message2shot = None, area2shot = None):
    
    '''
    gets Sphere4Xi
    '''
    
    global Sphere4Xi                                                     #Sphere
    
    global area2ball4xi                                                  #01 area
    global color2ball4xi                                                 #02 color
    global id2ball4xi                                                    #03 ID
    global radius2ball4xi                                                #04 radius
    global time2ball4xi                                                  #05 time
    global verb2ball4xi                                                  #06 verb
    global volume2ball4xi                                                #07 volume
    global x2ball4xi                                                     #08 x
    global y2ball4xi                                                     #09 y
    global z2ball4xi                                                     #10 z
    global message2ball4xi                                               #11 message
    
                                                                         #Shot
    global accerelation2shot4xi                                          #01 accerelation
    global azimuth2shot4xi                                               #02 azimuth-angle
    global color2shot4xi                                                 #03 color
    global elevation2shot4xi                                             #04 elevation-angle
    global id2shot4xi                                                    #05 ID
    global time2shot4xi                                                  #06 time
    global velocity2shot4xi                                              #07 velocity
    global verb2shot4xi                                                  #08 verb
    global x2shot4xi                                                     #09 x
    global y2shot4xi                                                     #10 y
    global z2shot4xi                                                     #11 z
    global distance2shot4xi                                              #12 distance
    global message2shot4xi                                               #13 message
    global area2shot4xi                                                  #14 area 
                                                                                      
                                                                         #Measures
    global ack2sphere                                                    #01 sphere   
    global ack2area                                                      #02 surface area
    global ack2volume                                                    #03 volume 
    global ack2shot                                                      #04 shot  
    
    global ack2debug
               
                       
    # -----------------------------------------------------------------------------------------
    # (Step 1/5)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get_ball4xi"
    method2print = "get_ball4xi"

    message2print = "{(Step 1/3a) started" + "; get_ball4xi-started: " + str(get_ball4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
    
    # -----------------------------------------------------------------------------------------
    # SPHERE           
    # -----------------------------------------------------------------------------------------  
        
    message2print = "{(Step 1/5a1) passed" + "; area2ball-to-get_ball4xi: " + str(area2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      

    message2print = "{(Step 1/5a2) passed" + "; color2ball-to-get_ball4xi: " + str(color2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    
    message2print = "{(Step 1/5a3) passed" + "; id2ball-to-get_ball4xi: " + str(id2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  

    message2print = "{(Step 1/5a4) passed" + "; radius2ball-to-get_ball4xi: " + str(radius2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  

    message2print = "{(Step 1/5a5) passed" + "; time2ball-to-get_ball4xi: " + str(time2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{(Step 1/5a6) passed" + "; verb2ball-to-get_ball4xi: " + str(verb2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    message2print = "{(Step 1/5a7) passed" + "; volume2ball-to-get_ball4xi: " + str(volume2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                                      
    message2print = "{(Step 1/5a8) passed" + "; x2ball-to-get_ball4xi: " + str(x2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{(Step 1/5a9) passed" + "; y2ball-to-get_ball4xi: " + str(y2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{(Step 1/5a10) passed" + "; z2ball-to-get_ball4xi: " + str(z2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{(Step 1/5a11) passed" + "; message2ball-to-get_ball4xi: " + str(message2ball) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
    
    # -----------------------------------------------------------------------------------------
    # SHOT           
    # -----------------------------------------------------------------------------------------  

    message2print = "{(Step 1/5b1) passed" + "; accerelation2shot-to-get_ball4xi: " + str(accerelation2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{(Step 1/5b2) passed" + "; azimuth2shot-to-get_ball4xi: " + str(azimuth2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{(Step 1/5b3) passed" + "; color2shot-to-get_ball4xi: " + str(color2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{(Step 1/5b4) passed" + "; elevation2shot-to-get_ball4xi: " + str(elevation2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  

    message2print = "{(Step 1/5b5) passed" + "; id2shot-to-get_ball4xi: " + str(id2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
         
    message2print = "{(Step 1/5b6) passed" + "; time2shot-to-get_ball4xi: " + str(time2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
            
    message2print = "{(Step 1/5b7) passed" + "; time2shot-to-get_ball4xi: " + str(time2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{(Step 1/5b8) passed" + "; velocity2shot-to-get_ball4xi: " + str(velocity2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{(Step 1/5b9) passed" + "; x2shot-to-get_ball4xi: " + str(x2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{(Step 1/5b10) passed" + "; y2shot-to-get_ball4xi: " + str(y2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{(Step 1/5b11) passed" + "; z2shot-to-get_ball4xi: " + str(z2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                         
    message2print = "{(Step 1/5b12) passed" + "; distance2shot-to-get_ball4xi: " + str(distance2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                     
    message2print = "{(Step 1/5b13) passed" + "; message2shot-to-get_ball4xi: " + str(message2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                     
    message2print = "{(Step 1/5b14) passed" + "; area2shot-to-get_ball4xi: " + str(area2shot) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                        
    # -----------------------------------------------------------------------------------------
    # GET ONLY REQUIRED ATTRIBUTES FOR BALL OR WITH NO PARAMETERS SPHERE4XI       
    # -----------------------------------------------------------------------------------------                  
    ack2created = False                                                  # track created ones
    
    # -----------------------------------------------------------------------------------------
    # (Step 2/5) BALL           
    # -----------------------------------------------------------------------------------------  
                                                                         # build the response ball                                                                          
    ball2xi = {}
    
    request2ball = False
    request2shot = False
     
    if ((id2ball is None) and (x2ball is None) and (y2ball is None) and (z2ball is None) and (radius2ball is None)
                              and (volume2ball is None) and (area2ball is None) and (color2ball is None) and (verb2ball is None)
                              and (time2ball is None) and (message2ball is None)):
                              
        request2wanted = 'no sphere requests specified'
        message2print = "{(Step 2/5a0) decided" + "; request2wanted-decided-by-get_ball4xi: " + str(request2wanted) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                                  
    
    else:                                                                # return required Sphere values
        ack2created = True 
      
        request2wanted = 'sphere requests specified'
        message2print = "{(Step 2/5a0) decided" + "; request2wanted-decided-by-get_ball4xi: " + str(request2wanted) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
              
        request2ball = True
        ball2xi[id2ball4xi] = {}
        
        message2print = "{(Step 2/5a0) using" + "; ball2xi-using-by-get_ball4xi: " + str(ball2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        
                
        #1    
        try:
            if area2ball == 'Yes':
                ball2xi[id2ball4xi] ['area2ball']    = area2ball4xi  
        except:
            message2print = "{(Step 2/5a1) yielded" + "; area2ball4xi-yielded-by-get_ball4xi: " + str(area2ball4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False        
        #2           
        try:
            if color2ball == 'Yes':
                ball2xi[id2ball4xi] ['color2ball']   = color2ball4xi 
        except:
            message2print = "{(Step 2/5a2) yielded" + "; color2ball4xi-yielded-by-get_ball4xi: " + str(color2ball4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False                    
        #3           
        try:
            if id2ball == 'Yes':
                ball2xi[id2ball4xi] ['id2ball']   = id2ball4xi 
        except:
            message2print = "{(Step 2/5a3) yielded" + "; id2ball4xi-yielded-by-get_ball4xi: " + str(id2ball4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False        
        #4    
        try:
            if radius2ball == 'Yes':
                ball2xi[id2ball4xi] ['radius2ball']  = radius2ball4xi 
        except:
            message2print = "{(Step 2/5a4) yielded" + "; radius2ball4xi-yielded-by-get_ball4xi: " + str(radius2ball4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False       
        #5           
        try:
            if time2ball == 'Yes':
                ball2xi[id2ball4xi] ['time2ball']   = time2ball4xi
        except:
            message2print = "{(Step 2/5a5) yielded" + "; time2ball4xi-yielded-by-get_ball4xi: " + str(time2ball4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False       
        #6           
        try:
            if verb2ball == 'Yes':
                ball2xi[id2ball4xi] ['verb2ball']   = verb2ball4xi
        except:
            message2print = "{(Step 2/5a6) yielded" + "; verb2ball4xi-yielded-by-get_ball4xi: " + str(verb2ball4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False          
        #7            
        try:
            if volume2ball == 'Yes':
                ball2xi[id2ball4xi] ['volume2ball']  = volume2ball4xi                                                     
        except:
            message2print = "{(Step 2/5a7) yielded" + "; volume2ball4xi-yielded-by-get_ball4xi: " + str(volume2ball4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False          
        #8       
        try:
            if x2ball == 'Yes':
                ball2xi[id2ball4xi] ['x2ball'] = x2ball4xi
        except:
            message2print = "{(Step 2/5a8) yielded" + "; x2ball4xi-yielded-by-get_ball4xi: " + str(x2ball4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False          
        #9    
        try:
            if y2ball == 'Yes':
                ball2xi[id2ball4xi] ['y2ball'] = y2ball4xi
        except:
            message2print = "{(Step 2/5a9) yielded" + "; y2ball4xi-yielded-by-get_ball4xi: " + str(y2ball4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False          
        #10    
        try:
            if z2ball == 'Yes':
                ball2xi[id2ball4xi] ['z2ball'] = z2ball4xi
        except:
            message2print = "{(Step 2/5a10) yielded" + "; z2ball4xi-yielded-by-get_ball4xi: " + str(z2ball4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False 
        #11    
        try:
            if message2ball == 'Yes':
                ball2xi[id2ball4xi] ['message2ball'] = message2ball4xi
        except:
            message2print = "{(Step 2/5a11) yielded" + "; message2ball4xi-yielded-by-get_ball4xi: " + str(message2ball4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False 
                
    # -----------------------------------------------------------------------------------------
    # (Step 3/5) SHOT           
    # -----------------------------------------------------------------------------------------  
                    
    if ((accerelation2shot is None) and (azimuth2shot is None) and (color2shot is None) and (elevation2shot is None) and (time2shot is None) 
                                    and (velocity2shot is None) and (x2shot is None) and (y2shot is None) and (z2shot is None) and (distance2shot is None) and (message2shot is None)):
                                    
        request2wanted = 'no shot requests specified'
        message2print = "{(Step 3/5a1) decided" + "; request2wanted-decided-by-get_ball4xi: " + str(request2wanted) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
             
    else:
        ack2created = True     
    
        request2shot = True
        
        if id2shot4xi == '0x0y0z':
            id2shot4xi = '0x0y1z'
        
        if request2ball is True:
            ball2xi[id2shot4xi] = {}                                                     # both ball and shot info required
            
            request2wanted = 'both ball and shot requests specified'
            message2print = "{(Step 3/5a2) decided" + "; request2wanted-decided-by-get_ball4xi: " + str(request2wanted) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            
        else:
            ball2xi = {}                                                                 # only shot info required   
            ball2xi[id2shot4xi] = {}  
                 
            request2wanted = 'only shot requests specified'
            message2print = "{(Step 3/5a3) decided" + "; request2wanted-decided-by-get_ball4xi: " + str(request2wanted) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)
            
            message2print = "{(Step 3/5a3) using" + "; id2shot4xi-using-by-get_ball4xi: " + str(id2shot4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
            
            message2print = "{(Step 3/5a4) using" + "; ball2xi-using-by-get_ball4xi: " + str(ball2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
            if id2shot4xi == '0x0y0z':
                
                message2print = "{(Step 3/5a5) yielded" + "; id2shot4xi-yielded-by-get_ball4xi: " + str(id2shot4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                
                id2shot4xi = '0x0y1z'
                                   
        #1           
        try:
            if accerelation2shot == 'Yes':
                ball2xi[id2shot4xi] ['accerelation2shot']   = accerelation2shot4xi 
        except:
            message2print = "{(Step 3/5b1) yielded" + "; accerelation2shot4xi-yielded-by-get_ball4xi: " + str(accerelation2shot4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False                      
        #2           
        try:
            if azimuth2shot == 'Yes':
                ball2xi[id2shot4xi] ['azimuth2shot']   = azimuth2shot4xi 
        except:
            message2print = "{(Step 3/5b2) yielded" + "; azimuth2shot4xi-yielded-by-get_ball4xi: " + str(azimuth2shot4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False                       
        #3           
        try:
            if color2shot == 'Yes':
                ball2xi[id2shot4xi] ['color2shot']   = color2shot4xi 
        except:
            message2print = "{(Step 3/5b3) yielded" + "; color2shot4xi-yielded-by-get_ball4xi: " + str(color2shot4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False                       
        #4           
        try:
            if elevation2shot == 'Yes':
                ball2xi[id2shot4xi] ['elevation2shot']   = elevation2shot4xi 
        except:
            message2print = "{(Step 3/5b4) yielded" + "; elevation2shot4xi-yielded-by-get_ball4xi: " + str(elevation2shot4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False           
        #5           
        try:
            if id2shot == 'Yes':
                if id2shot4xi == '0x0y0z':
                    id2shot4xi = '0x0y1z'
                ball2xi[id2shot4xi] ['id2shot']   = id2shot4xi 
        except:
            message2print = "{(Step 3/5b5) yielded" + "; id2shot4xi-yielded-by-get_ball4xi: " + str(id2shot4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False                               
        #6           
        try:
            if time2shot == 'Yes':
                ball2xi[id2shot4xi] ['time2shot']   = time2shot4xi 
        except:
            message2print = "{(Step 3/5b6) yielded" + "; time2shot4xi-yielded-by-get_ball4xi: " + str(time2shot4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False                       
        #7           
        try:
            if velocity2shot == 'Yes':
                ball2xi[id2shot4xi] ['velocity2shot']   = velocity2shot4xi 
        except:
            message2print = "{(Step 3/5b7) yielded" + "; velocity2shot4xi-yielded-by-get_ball4xi: " + str(velocity2shot4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False   
        #8           
        try:
            if verb2shot == 'Yes':
                ball2xi[id2shot4xi] ['verb2shot']   = verb2shot4xi 
        except:
            message2print = "{(Step 3/5b8) yielded" + "; verb2shot4xi-yielded-by-get_ball4xi: " + str(verb2shot4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False                                
        #9           
        try:
            if x2shot == 'Yes':
                ball2xi[id2shot4xi] ['x2shot']   = x2shot4xi 
        except:
            message2print = "{(Step 3/5b9) yielded" + "; x2shot4xi-yielded-by-get_ball4xi: " + str(x2shot4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False                       
        #10           
        try:
            if y2shot == 'Yes':
                ball2xi[id2shot4xi] ['y2shot']   = y2shot4xi 
        except:
            message2print = "{(Step 3/5b10) yielded" + "; y2shot4xi-yielded-by-get_ball4xi: " + str(y2shot4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False                                                                          
        #11            
        try:
            if z2shot == 'Yes':
                ball2xi[id2shot4xi] ['z2shot']   = z2shot4xi 
        except:
            message2print = "{(Step 3/5b11) yielded" + "; z2shot4xi-yielded-by-get_ball4xi: " + str(z2shot4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False
        #12            
        try:
            if distance2shot == 'Yes':
                ball2xi[id2shot4xi] ['distance2shot']   = distance2shot4xi 
        except:
            message2print = "{(Step 3/5b12) yielded" + "; distance2shot4xi-yielded-by-get_ball4xi: " + str(distance2shot4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False
        #13            
        try:
            if message2shot == 'Yes':
                ball2xi[id2shot4xi] ['message2shot']  = message2shot4xi 
        except:
            message2print = "{(Step 3/5b13) yielded" + "; message2shot4xi-yielded-by-get_ball4xi: " + str(message2shot4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False
        #14            
        try:
            if area2shot == 'Yes':
                ball2xi[id2shot4xi] ['area2shot']  = area2shot4xi 
        except:
            message2print = "{(Step 3/5b14) yielded" + "; area2shot4xi-yielded-by-get_ball4xi: " + str(area2shot4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2shot = False
                                            
        message2print = "{(Step 3/6) created" + "; ball2xi-created-by-get_ball4xi: " + str(ball2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        ack2created = True
                               
   
    # -----------------------------------------------------------------------------------------
    # (Step 4/5) BALL OR SPHERE RETURNED           
    # -----------------------------------------------------------------------------------------  
    if ack2created is True:
        created2xi = 'either sphere or shot or information of both ones created for request'
        message2print = "{(Step 4/5c) decided" + "; created2xi-decided-by-get_ball2xi: " + str(created2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
    else:                      
        try:                
            if ((id2ball is None) and (x2ball is None) and (y2ball is None) and (z2ball is None) and (radius2ball is None)
                              and (volume2ball is None) and (area2ball is None) and (color2ball is None) and (verb2ball is None)
                              and (time2ball is None) and (accerelation2shot is None) and (azimuth2shot is None) and (color2shot is None) and (elevation2shot is None) 
                              and (time2shot is None) and (velocity2shot is None) and (x2shot is None) and (y2shot is None) and (z2shot is None)
                              and (distance2shot is None) and (message2shot is None)  and (area2shot is None)):
                              
                request2wanted = 'neither sphere nor shot requests specified - assuming both wanted'
                message2print = "{(Step 4/5a) decided" + "; request2wanted-decided-by-get_ball4xi: " + str(request2wanted) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                          
                              
                ball2xi = Sphere4Xi          # no parameters given - return the whole Spehere4Xi
        
                message2print = "{(Step 4/5b) decided" + "; Sphere4Xi-decided-by-get_ball2xi: " + str(Sphere4Xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # {'0x0y1z': {'time2shot': 0, 'accerelation2shot': 0, 'x2shot': 0, 'azimuth2shot': 0, 'velocity2shot': 0, 'verb2shot': 'skeletonizing', 'y2shot': 0, 'z2shot': 1, 'elevation2shot': 0, 'color2shot': 0}, 
                #  '0x0y0z': {'radius2ball': 1, 'x2ball': 0, 'z2ball': 0, 'area2ball': 12.566370614359172, 'color2ball': '#F5E8E8', 'y2ball': 0, 'id2ball': '0x0y0z', 'verb2ball': 'skeletonize', 'time2ball': 0, 'volume2ball': 4.1887902047863905}}; time: 02:08:35 05/22/10 Pacific Daylight Time}
            else:
                
                unresolved2xi = '*** requests make no sense - examine them ***'
                message2print = "{(Step 4/5c) decided" + "; unresolved2xi-decided-by-get_ball2xi: " + str(unresolved2xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)            
                
                ball2xi = {}
        except:
            message2print = "{(Step 4/5d) yielded" + "; ball2xi-yielded-by-get_ball4xi: " + str(ball2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            ack2ball = False     

            
    # -----------------------------------------------------------------------------------------
    # (Step 5/5)           
    # -----------------------------------------------------------------------------------------
    
    message2print = "{(Step 5/5) returning" + "; ball2xi-returning-by-get_ball4xi: " + str(ball2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)    
                            
    
    return ball2xi    
        
#</function4xi>
 
                                               
# =================================================================================================
#<class4xi class = "Ball4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for ball4xi module" usage = "3D"
#>
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
class Ball4Xi(object): 
    ''' 
    Ball4Xi offers  methods for ball4xi objects
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    color = '#F08C27'
    backgroundcolor = '#37332E'
    
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
    'init',
    'set',
    'get',  
    'sense',
    'reason',
    'ace')          
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-Ball4Xi" usage = "initializes Ball4Xi">
    #<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    #                    1        2        3              4             5                      6                          7          8
    def __init__(self, x2ball=0, y2ball=0, z2ball=0, radius2ball=1, color2ball = '#F5E8E8', verb2ball = 'skeletonize', time2ball=0, message2ball = 'MainProcess4Xi',
    #                    9                10              11                          12               13              14                15            
                 accerelation2shot = 0, azimuth2shot = 0, color2shot = '#F3881C', elevation2shot = 0, time2shot = 0, velocity2shot = 0, verb2shot = 0,
    #             16          17          18            19                 20                                 21                        
                 x2shot = 0, y2shot = 0, z2shot = 0, distance2shot = 1, message2shot = 'CurrentProcess4Xi', area2shot = 0): 
                  
        '''
        initializes Sphere4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/3)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "Ball4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1/3a) started" + "; init-of-Ball4Xi-started: "  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   

        message2print = "{(Step 1/3b) borning" + "; ball2xi-of-Ball4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
                
        message2print = "{(Step 1/3c) inheriting" + "; object-inheriting-by-ball2xi-of-Ball4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        message2print = "{(Step 1/3d) sharing" + "; color-sharing-by-ball2xi-of-Ball4Xi: " + str(Ball4Xi.color)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      

        message2print = "{(Step 1/3e) sharing" + "; backgroundcolor-sharing-by-ball2xi-of-Ball4Xi: " + str(Ball4Xi.backgroundcolor)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
        
        # -----------------------------------------------------------------------------------------
        # BALL           
        # -----------------------------------------------------------------------------------------
             
        #1                                
        message2print = "{(Step 1/3f1) passed" + "; x2ball-passed-to-init-of-Ball4Xi: " + str(x2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        #2                                           
        message2print = "{(Step 1/3f2) passed" + "; y2ball-passed-to-init-of-Ball4Xi: " + str(y2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
        #3                                 
        message2print = "{(Step 1/3f3) passed" + "; z2ball-passed-to-init-of-Ball4Xi: " + str(z2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        #4                                           
        message2print = "{(Step 1/3f4) passed" + "; radius2ball-passed-to-init-of-Ball4Xi: " + str(radius2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
        #5                                           
        message2print = "{(Step 1/3f5) passed" + "; color2ball-passed-to-init-of-Ball4Xi: " + str(color2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
        #6                                           
        message2print = "{(Step 1/3f6) passed" + "; verb2ball-passed-to-init-of-Ball4Xi: " + str(verb2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
        #7                                           
        message2print = "{(Step 1/3f7) passed" + "; time2ball-passed-to-init-of-Ball4Xi: " + str(time2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
        #8                                           
        message2print = "{(Step 1/3f8) passed" + "; message2ball-passed-to-init-of-Ball4Xi: " + str(message2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
              
        # -----------------------------------------------------------------------------------------
        # SHOT           
        # -----------------------------------------------------------------------------------------
             
        #9                                           
        message2print = "{(Step 1/3f9) passed" + "; accerelation2shot-passed-to-init-of-Ball4Xi: " + str(accerelation2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
        #10                                           
        message2print = "{(Step 1/3f10) passed" + "; azimuth2shot-passed-to-init-of-Ball4Xi: " + str(azimuth2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
        #11                                           
        message2print = "{(Step 1/3f11) passed" + "; color2shot-passed-to-init-of-Ball4Xi: " + str(color2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
        #12                                           
        message2print = "{(Step 1/3f12) passed" + "; elevation2shot-passed-to-init-of-Ball4Xi: " + str(elevation2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                                             
        
        #13                                           
        message2print = "{(Step 1/3f13) passed" + "; time2shot-passed-to-init-of-Ball4Xi: " + str(time2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
        #14                                           
        message2print = "{(Step 1/3f14) passed" + "; velocity2shot-passed-to-init-of-Ball4Xi: " + str(velocity2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
        #15                                           
        message2print = "{(Step 1/3f15) passed" + "; verb2shot-passed-to-init-of-Ball4Xi: " + str(verb2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
               
        #16                                           
        message2print = "{(Step 1/3f16) passed" + "; x2shot-passed-to-init-of-Ball4Xi: " + str(x2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
        #17                                           
        message2print = "{(Step 1/3f17) passed" + "; y2shot-passed-to-init-of-Ball4Xi: " + str(y2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
        #18                                           
        message2print = "{(Step 1/3f18) passed" + "; z2shot-passed-to-init-of-Ball4Xi: " + str(z2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
        #19                                           
        message2print = "{(Step 1/3f19) passed" + "; distance2shot-passed-to-init-of-Ball4Xi: " + str(distance2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
        #20                                           
        message2print = "{(Step 1/3f20) passed" + "; message2shot-passed-to-init-of-Ball4Xi: " + str(message2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
        #21                                           
        message2print = "{(Step 1/3f21) passed" + "; area2shot-passed-to-init-of-Ball4Xi: " + str(area2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                                                  
        # -----------------------------------------------------------------------------------------
        # (Step 2/3)             
        # -----------------------------------------------------------------------------------------
 
                                                
        # -----------------------------------------------------------------------------------------
        # BALL             
        # -----------------------------------------------------------------------------------------
              
               
        message2print = "{(Step 2/3a1) passing" + "; x2ball-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(x2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3a2) passing" + "; y2ball-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(y2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
        
        message2print = "{(Step 2/3a3) passing" + "; z2ball-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(z2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3a4) passing" + "; radius2ball-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(radius2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
        
        message2print = "{(Step 2/3a5) passing" + "; color2ball-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(color2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
                   
        message2print = "{(Step 2/3a6) passing" + "; verb2ball-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(verb2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
 
        message2print = "{(Step 2/3a7) passing" + "; time2ball-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(time2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
 
        message2print = "{(Step 2/3a8) passing" + "; message2ball-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(message2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
                                                      
        # -----------------------------------------------------------------------------------------
        # SHOT             
        # -----------------------------------------------------------------------------------------
     
        message2print = "{(Step 2/3a9) passing" + "; accerelation2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(accerelation2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
    
        message2print = "{(Step 2/3a10) passing" + "; azimuth2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(azimuth2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
 
        message2print = "{(Step 2/3a11) passing" + "; color2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(color2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
 
        message2print = "{(Step 2/3a12) passing" + "; elevation2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(elevation2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
 
        message2print = "{(Step 2/3a13) passing" + "; time2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(time2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
 
        message2print = "{(Step 2/3a14) passing" + "; velocity2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(velocity2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
 
        message2print = "{(Step 2/3a15) passing" + "; verb2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(verb2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
  
        message2print = "{(Step 2/3a16) passing" + "; x2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(x2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
 
        message2print = "{(Step 2/3a17) passing" + "; y2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(y2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
 
        message2print = "{(Step 2/3a18) passing" + "; z2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(z2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
                                      
        message2print = "{(Step 2/3a19) passing" + "; distance2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(distance2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
                                      
        message2print = "{(Step 2/3a20) passing" + "; message2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(message2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
                                      
        message2print = "{(Step 2/3a21) passing" + "; area2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(area2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
                                                              
        # -----------------------------------------------------------------------------------------
        #        
        # -----------------------------------------------------------------------------------------
                         
        init_ball4xi(x2ball,y2ball,z2ball, radius2ball, color2ball, verb2ball, time2ball, message2ball, accerelation2shot, azimuth2shot, color2shot, elevation2shot, time2shot, velocity2shot, verb2shot, x2shot, y2shot, z2shot,distance2shot, message2shot)
        
        message2print = "{(Step 2/3b) performed" + "; init_ball4xi-performed-by-init-of-Ball4Xi: " + str(init_ball4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                        
        # -----------------------------------------------------------------------------------------
        # (Step 3/3)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3/3a) activated" + "; ball2xi-of-Ball4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                
        message2print = "{(Step 3/3b) inherited" + "; object-inherited-by-ball2xi-of-Ball4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        message2print = "{(Step 3/3d) shared" + "; color-sharing-by-ball2xi-of-Ball4Xi: " + str(Ball4Xi.color)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      

        message2print = "{(Step 3/3e) shared" + "; backgroundcolor-sharing-by-ball2xi-of-Ball4Xi: " + str(Ball4Xi.backgroundcolor)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                           
       
        message2print = "{(Step 3/3d) returning"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-Ball4Xi" usage = "initializes objects of Ball4Xi">
    #<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def init(self, x2ball=0,y2ball=0,z2ball=0, radius2ball=1, color2ball = '#F5E8E8', verb2ball = 'skeletonize', time2ball=0, message2ball = 'MainProcess4Xi',
                 accerelation2shot = 0, azimuth2shot = 0, color2shot = '#F3881C', elevation2shot = 0, time2shot = 0, velocity2shot = 0, verb2shot = 'skeletonizing', 
                 x2shot = 0, y2shot = 0, z2shot = 0, distance2shot = 1, message2shot = 'CurrentProcess4Xi', area2shot = 0): 

        '''
        initializes objects of Ball4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/3)           
        # ----------------------------------------------------------------------------------------- 
                     
        class2print = "Ball4Xi"
        method2print = "init"
                     
        message2print = "{(Step 1/3a) started" + "; init-of-Ball4Xi-started: "  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   

        # -----------------------------------------------------------------------------------------
        # BALL           
        # ----------------------------------------------------------------------------------------- 
                                 
        message2print = "{(Step 1/3b1) passed" + "; x2ball-passed-to-init-of-Ball4Xi: " + str(x2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        
        message2print = "{(Step 1/3b2) passed" + "; y2ball-passed-to-init-of-Ball4Xi: " + str(y2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                     
        message2print = "{(Step 1/3b3) passed" + "; z2ball-passed-to-init-of-Ball4Xi: " + str(z2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/3b4) passed" + "; radius2ball-passed-to-init-of-Ball4Xi: " + str(radius2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/3b5) passed" + "; color2ball-passed-to-init-of-Ball4Xi: " + str(color2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/3b6) passed" + "; verb2ball-passed-to-init-of-Ball4Xi: " + str(verb2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/3b7) passed" + "; time2ball-passed-to-init-of-Ball4Xi: " + str(time2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/3b8) passed" + "; message2ball-passed-to-init-of-Ball4Xi: " + str(message2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)

        # -----------------------------------------------------------------------------------------
        # SHOT           
        # ----------------------------------------------------------------------------------------- 
             
        message2print = "{(Step 1/3b9) passed" + "; accerelation2shot-passed-to-init-of-Ball4Xi: " + str(accerelation2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/3b10) passed" + "; azimuth2shot-passed-to-init-of-Ball4Xi: " + str(azimuth2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/3b11) passed" + "; color2shot-passed-to-init-of-Ball4Xi: " + str(color2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/3b12) passed" + "; elevation2shot-passed-to-init-of-Ball4Xi: " + str(elevation2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/3b13) passed" + "; time2shot-passed-to-init-of-Ball4Xi: " + str(time2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/3b14) passed" + "; velocity2shot-passed-to-init-of-Ball4Xi: " + str(velocity2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/3b15) passed" + "; verb2shot-passed-to-init-of-Ball4Xi: " + str(verb2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
             
        message2print = "{(Step 1/3b16) passed" + "; x2shot-passed-to-init-of-Ball4Xi: " + str(x2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/3b17) passed" + "; y2shot-passed-to-init-of-Ball4Xi: " + str(y2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/3b18) passed" + "; z2shot-passed-to-init-of-Ball4Xi: " + str(z2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/3b19) passed" + "; distance2shot-passed-to-init-of-Ball4Xi: " + str(distance2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/3b20) passed" + "; message2shot-passed-to-init-of-Ball4Xi: " + str(message2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/3b21) passed" + "; area2shot-passed-to-init-of-Ball4Xi: " + str(area2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                                                                                                      
        # -----------------------------------------------------------------------------------------
        # (Step 2/3)           
        # -----------------------------------------------------------------------------------------
        

        # -----------------------------------------------------------------------------------------
        # BALL           
        # ----------------------------------------------------------------------------------------- 
             
        
        message2print = "{(Step 2/3a1) passing" + "; x2ball-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(x2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3a2) passing" + "; y2ball-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(y2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3a3) passing" + "; z2ball-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(z2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3a4) passing" + "; radius2ball-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(radius2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3a5) passing" + "; color2ball-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(color2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3a6) passing" + "; verb2ball-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(verb2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3a7) passing" + "; time2ball-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(time2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3a8) passing" + "; message2ball-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(message2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            

        # -----------------------------------------------------------------------------------------
        # SHOT           
        # ----------------------------------------------------------------------------------------- 
             
        message2print = "{(Step 2/3a9) passing" + "; accerelation2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(accerelation2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3a10) passing" + "; azimuth2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(azimuth2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3a11) passing" + "; color2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(color2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3a12) passing" + "; elevation2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(elevation2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3a13) passing" + "; time2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(time2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3a14) passing" + "; velocity2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(velocity2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3a15) passing" + "; verb2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(verb2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
            
        message2print = "{(Step 2/3a16) passing" + "; x2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(x2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3a17) passing" + "; y2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(y2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3a18) passing" + "; z2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(z2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3a19) passing" + "; distance2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(distance2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3a20) passing" + "; message2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(message2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3a21) passing" + "; area2shot-passing-to-init_ball4xi-by-init-of-Ball4Xi: " + str(area2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            

        # -----------------------------------------------------------------------------------------
        #        
        # ----------------------------------------------------------------------------------------- 
                                                        
        init_ball4xi(x2ball,y2ball,z2ball, radius2ball, color2ball, verb2ball, time2ball, message2ball, accerelation2shot, azimuth2shot, color2shot, elevation2shot, 
                     time2shot, velocity2shot, verb2shot, x2shot, y2shot, z2shot, distance2shot, message2shot, area2shot)

        message2print = "{(Step 2/3f) performed" + "; init_ball4xi-performed-by-init-of-Ball4Xi: " + str(init_ball4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/3)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/3) returning" + "; init-of-Ball4Xi-returning: "  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                                
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-of-Ball4Xi" usage = "sets objects of Ball4Xi">
    #<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def set(self, x2ball=None,y2ball=None,z2ball=None, radius2ball=None, color2ball=None, verb2ball=None, time2ball = None, message2ball = None,   
                accerelation2shot = None, azimuth2shot = None, color2shot = None, elevation2shot = None, time2shot = None, velocity2shot = None, 
                verb2shot = None, x2shot = None, y2shot = None, z2shot = None, distance2shot = None, message2shot = None, area2shot = None):
        '''
        sets objects of Ball4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/3)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Ball4Xi"
        method2print = "set"
                     
        message2print = "{(Step 1/3a) started" + "; set-of-Ball4Xi-started: "  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   

        # -----------------------------------------------------------------------------------------
        # BALL           
        # ----------------------------------------------------------------------------------------- 
                 
        message2print = "{(Step 1/3b1) passed" + "; x2ball-passed-to-set-of-Ball4Xi: " + str(x2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        
        message2print = "{(Step 1/3b2) passed" + "; y2ball-passed-to-set-of-Ball4Xi: " + str(y2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                     
        message2print = "{(Step 1/3b3) passed" + "; z2ball-passed-to-set-of-Ball4Xi: " + str(z2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/3b4) passed" + "; radius2ball-passed-to-set-of-Ball4Xi: " + str(radius2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/3b5) passed" + "; color2ball-passed-to-set-of-Ball4Xi: " + str(color2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/3b6) passed" + "; verb2ball-passed-to-set-of-Ball4Xi: " + str(verb2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/3b7) passed" + "; time2ball-passed-to-set-of-Ball4Xi: " + str(time2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)

        message2print = "{(Step 1/3b8) passed" + "; message2ball-passed-to-set-of-Ball4Xi: " + str(message2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
                                                    
        # -----------------------------------------------------------------------------------------
        # SHOT           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2/3c1) passing" + "; x2ball-passing-to-set_ball4xi-by-set-of-Ball4Xi: " + str(x2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3c2) passing" + "; y2ball-passing-to-set_ball4xi-by-set-of-Ball4Xi: " + str(y2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3c3) passing" + "; z2ball-passing-to-set_ball4xi-by-set-of-Ball4Xi: " + str(z2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3c4) passing" + "; radius2ball-passing-to-set_ball4xi-by-set-of-Ball4Xi: " + str(radius2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                            
        message2print = "{(Step 2/3c5) passing" + "; color2ball-passing-to-set_ball4xi-by-set-of-Ball4Xi: " + str(color2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                            
        message2print = "{(Step 2/3c6) passing" + "; verb2ball-passing-to-set_ball4xi-by-set-of-Ball4Xi: " + str(verb2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3c7) passing" + "; time2ball-passing-to-set_ball4xi-by-set-of-Ball4Xi: " + str(time2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3c8) passing" + "; accerelation2shot-passing-to-set_ball4xi-by-set-of-Ball4Xi: " + str(accerelation2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3c9) passing" + "; azimuth2shot-passing-to-set_ball4xi-by-set-of-Ball4Xi: " + str(azimuth2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3c10) passing" + "; color2shot-passing-to-set_ball4xi-by-set-of-Ball4Xi: " + str(color2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3c11) passing" + "; elevation2shot-passing-to-set_ball4xi-by-set-of-Ball4Xi: " + str(elevation2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3c12) passing" + "; time2shot-passing-to-set_ball4xi-by-set-of-Ball4Xi: " + str(time2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3c13) passing" + "; velocity2shot-passing-to-set_ball4xi-by-set-of-Ball4Xi: " + str(velocity2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3c14) passing" + "; verb2shot-passing-to-set_ball4xi-by-set-of-Ball4Xi: " + str(verb2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
              
        message2print = "{(Step 2/3c15) passing" + "; x2shot-passing-to-set_ball4xi-by-set-of-Ball4Xi: " + str(x2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3c16) passing" + "; y2shot-passing-to-set_ball4xi-by-set-of-Ball4Xi: " + str(y2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3c17) passing" + "; z2shot-passing-to-set_ball4xi-by-set-of-Ball4Xi: " + str(z2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3c18) passing" + "; distance2shot-passing-to-set_ball4xi-by-set-of-Ball4Xi: " + str(distance2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3c19) passing" + "; message2shot-passing-to-set_ball4xi-by-set-of-Ball4Xi: " + str(message2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/3c20) passing" + "; area2shot-passing-to-set_ball4xi-by-set-of-Ball4Xi: " + str(area2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                      
        # -----------------------------------------------------------------------------------------
        #            
        # -----------------------------------------------------------------------------------------                                                      
        #            1     2       3         4            5           6          7         8
        set_ball4xi(x2ball,y2ball, z2ball, radius2ball, color2ball, verb2ball, time2ball, message2ball,
        #                  8              9             10            11            12          13          
                   accerelation2shot, azimuth2shot, color2shot, elevation2shot, time2shot, velocity2shot, 
        #                  14     15      16       17        18            19          20   
                      verb2shot, x2shot, y2shot, z2shot, distance2shot, message2shot, area2shot)


        message2print = "{(Step 2/3f) performed" + "; set_ball4xi-performed-by-set-of-Ball4Xi: " + str(set_ball4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/3)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/3) returning" + "; set-of-Ball4Xi-returning: "  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                                
                            
    #</methodize4xi>


    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-of-Ball4Xi" usage = "gets objects of Ball4Xi">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    #                    1            2                 3               4                5                  6         7                 8              9      10              11
    def get(self, area2ball=None, color2ball=None, id2ball=None, radius2ball=None, time2ball = None, verb2ball=None, volume2ball=None, x2ball=None,y2ball=None,z2ball=None, message2ball = None,
    #                 1                      2                   3                    4                    5               6                 7                      8           
                accerelation2shot = None, azimuth2shot = None, color2shot = None, elevation2shot = None, id2shot = None, time2shot = None, velocity2shot = None, verb2shot = None, 
    #            9              10              11               12                  13                   14
                x2shot = None, y2shot = None, z2shot = None, distance2shot = None, message2shot = None, area2shot = None):
    
        
        '''
        gets objects of Ball4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/4)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Ball4Xi"
        method2print = "get"
                     
        message2print = "{(Step 1/2a) started" + "; get-of-Ball4Xi-started: "  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        # -----------------------------------------------------------------------------------------
        # BALL           
        # -----------------------------------------------------------------------------------------                 
        
        message2print = "{(Step 2/4a1) passed" + "; area2ball-passed-to-get-of-Ball4Xi: " + str(area2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        
        message2print = "{(Step 2/4a2) passed" + "; color2ball-passed-to-get-of-Ball4Xi: " + str(color2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        
        message2print = "{(Step 2/4a3) passed" + "; id2ball-passed-to-get-of-Ball4Xi: " + str(id2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        
        message2print = "{(Step 2/4a4) passed" + "; radius2ball-passed-to-get-of-Ball4Xi: " + str(radius2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        
        message2print = "{(Step 2/4a5) passed" + "; time2ball-passed-to-get-of-Ball4Xi: " + str(time2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        
        message2print = "{(Step 2/4a6) passed" + "; verb2ball-passed-to-get-of-Ball4Xi: " + str(verb2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        
        message2print = "{(Step 2/4a7) passed" + "; volume2ball-passed-to-get-of-Ball4Xi: " + str(volume2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        
        message2print = "{(Step 2/4a8) passed" + "; x2ball-passed-to-get-of-Ball4Xi: " + str(x2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
                          
        
        message2print = "{(Step 2/4a9) passed" + "; y2ball-passed-to-get-of-Ball4Xi: " + str(y2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
  
        message2print = "{(Step 2/4a10) passed" + "; z2ball-passed-to-get-of-Ball4Xi: " + str(z2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  
        message2print = "{(Step 2/4a11) passed" + "; message2ball-passed-to-get-of-Ball4Xi: " + str(message2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                             
        # -----------------------------------------------------------------------------------------
        # SHOT           
        # -----------------------------------------------------------------------------------------                 
        
        message2print = "{(Step 2/4b1) passed" + "; accerelation2shot-passed-to-get-of-Ball4Xi: " + str(accerelation2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                 
        
        message2print = "{(Step 2/4b2) passed" + "; azimuth2shot-passed-to-get-of-Ball4Xi: " + str(azimuth2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        message2print = "{(Step 2/4b3) passed" + "; color2shot-passed-to-get-of-Ball4Xi: " + str(color2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                 
        
        message2print = "{(Step 2/4b4) passed" + "; elevation2shot-passed-to-get-of-Ball4Xi: " + str(elevation2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
        message2print = "{(Step 2/4b5) passed" + "; id2shot-passed-to-get-of-Ball4Xi: " + str(id2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                 
        
        message2print = "{(Step 2/4b6) passed" + "; time2shot-passed-to-get-of-Ball4Xi: " + str(time2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        message2print = "{(Step 2/4b7) passed" + "; velocity2shot-passed-to-get-of-Ball4Xi: " + str(velocity2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                 
        
        message2print = "{(Step 2/4b8) passed" + "; verb2shot-passed-to-get-of-Ball4Xi: " + str(verb2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/4b9) passed" + "; x2shot-passed-to-get-of-Ball4Xi: " + str(x2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        message2print = "{(Step 2/4b10) passed" + "; y2shot-passed-to-get-of-Ball4Xi: " + str(y2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                 
        
        message2print = "{(Step 2/4b11) passed" + "; z2shot-passed-to-get-of-Ball4Xi: " + str(z2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/42b12) passed" + "; distance2shot-passed-to-get-of-Ball4Xi: " + str(distance2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/42b13) passed" + "; message2shot-passed-to-get-of-Ball4Xi: " + str(message2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        message2print = "{(Step 2/42b14) passed" + "; area2shot-passed-to-get-of-Ball4Xi: " + str(area2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                              
        # -----------------------------------------------------------------------------------------
        # (Step 3/4)           
        # -----------------------------------------------------------------------------------------
                     
        # -----------------------------------------------------------------------------------------
        # BALL           
        # -----------------------------------------------------------------------------------------
             
        message2print = "{(Step 3/4a1) passing" + "; area2ball-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(area2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
                 
        message2print = "{(Step 3/4a2) passing" + "; color2ball-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(color2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
        
        message2print = "{(Step 3/4a3) passing" + "; id2ball-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(id2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
                 
        message2print = "{(Step 3/4a4) passing" + "; radius2ball-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(radius2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
        
        message2print = "{(Step 3/4a5) passing" + "; time2ball-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(time2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
                 
        message2print = "{(Step 3/4a6) passing" + "; verb2ball-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(verb2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
        
        message2print = "{(Step 3/4a7) passing" + "; volume2ball-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(volume2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
                 
        message2print = "{(Step 3/4a8) passing" + "; x2ball-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(x2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
        
        message2print = "{(Step 3/4a9) passing" + "; y2ball-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(y2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
                 
        message2print = "{(Step 3/4a10) passing" + "; z2ball-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(z2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
                 
        message2print = "{(Step 3/4a11) passing" + "; message2ball-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(message2ball) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
                            
        # -----------------------------------------------------------------------------------------
        # SHOT           
        # -----------------------------------------------------------------------------------------
             
        message2print = "{(Step 3/4b1) passing" + "; accerelation2shot-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(accerelation2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
                 
        message2print = "{(Step 3/4b2) passing" + "; azimuth2shot-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(azimuth2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
        
        message2print = "{(Step 3/4b3) passing" + "; color2shot-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(color2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
                 
        message2print = "{(Step 3/4b4) passing" + "; elevation2shot-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(elevation2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
        
        message2print = "{(Step 3/4b5) passing" + "; id2shot-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(id2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
                 
        message2print = "{(Step 3/4b6) passing" + "; time2shot-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(time2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
                                             
                 
        message2print = "{(Step 3/4b7) passing" + "; velocity2shot-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(velocity2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
        
        message2print = "{(Step 3/4b8) passing" + "; verb2shot-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(verb2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
                 
        message2print = "{(Step 3/4b9) passing" + "; x2shot-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(x2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
        
        message2print = "{(Step 3/4b10) passing" + "; y2shot-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(y2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
                 
        message2print = "{(Step 3/4b11) passing" + "; z2shot-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(z2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
                 
        message2print = "{(Step 3/4b12) passing" + "; distance2shot-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(distance2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
                 
        message2print = "{(Step 3/4b13) passing" + "; message2shot-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(message2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
                 
        message2print = "{(Step 3/4b14) passing" + "; area2shot-passing-to-get_ball4xi-by-get-of-Ball4Xi: " + str(area2shot) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                      
                                                    
        # -----------------------------------------------------------------------------------------
        # (Step 4/4)       
        # -----------------------------------------------------------------------------------------
                                                                        
        message2print = "{(Step 4/4) returning" + "; get_ball4xi-function-returning-by-get-of-Ball4Xi: " + str(get_ball4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  

        #                    1           2          3          4            5          6          7          8      9      10        11                                                             
        return get_ball4xi(area2ball, color2ball, id2ball, radius2ball, time2ball, verb2ball, volume2ball, x2ball,y2ball,z2ball, message2ball,  
        #                    1                      2          3            4              5         6          7             8   
                           accerelation2shot, azimuth2shot, color2shot, elevation2shot, id2shot, time2shot, velocity2shot, verb2shot,
        #                    9      10       11       12               13          14                         
                            x2shot, y2shot, z2shot, distance2shot, message2shot, area2shot)


                            
    #</methodize4xi>                                     
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-Ball4Xi" usage = "senses Ball4Xi class objects">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        sense: senses Ball4Xi class objects
        '''
        global id2ball4xi
        global radius2ball4xi
        global distance2shot4xi             
                                                                             #Measures
        global ack2sphere                                                    #01 sphere   
        global ack2area                                                      #02 surface area
        global ack2volume                                                    #03 volume 
        global ack2shot                                                      #04 shot  
                          
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'Ball4Xi'
        method2print = 'sense'
        
                     
        message2print = "{started" + "; sense-of-Ball4Xi-started: "  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
    
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{sensing" + "; Ball4Xi-sensing-by-sense-of-Ball4Xi: " + str(Ball4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                        
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-Ball4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi ['time-sensing-of-Ball4Xi'] = time4xi()
            kb2xi ['color-of-Ball4Xi'] = Ball4Xi.color
            kb2xi ['backgroundcolor-of-Ball4Xi'] = Ball4Xi.backgroundcolor
            kb2xi ['ack2sphere'] = ack2sphere
            kb2xi ['ack2area'] = ack2area
            kb2xi ['ack2volume'] = ack2volume
            kb2xi ['ack2shot'] = ack2shot
            kb2xi ['distance2shot'] = distance2shot4xi 
            kb2xi ['radius2ball'] = radius2ball4xi
                                        
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-Ball4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{sensed" + "; Ball4Xi-sensed-by-sense-of-Ball4Xi: " + str(Ball4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-Ball4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-Ball4Xi" usage = "reasons Ball4Xi class objects">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        reasons Ball4Xi class objects
        '''
        global id2ball4xi 
                                                                             #Measures
        global ack2sphere                                                    #01 sphere   
        global ack2area                                                      #02 surface area
        global ack2volume                                                    #03 volume 
        global ack2shot                                                      #04 shot  
                                 
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'Ball4Xi'
        method2print = 'reason'

                     
        message2print = "{started" + "; reason-of-Ball4Xi-started: "  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
          
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{reasoning" + "; Ball4Xi-reasoning-by-reason-of-Ball4Xi: " + str(Ball4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-Ball4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi ['time-reasoning-of-Ball4Xi'] = time4xi()
            
            if ((ack2sphere is True) and (ack2area is True) and (ack2volume is True) and (ack2shot is True)):
                kb4xi['reasoned'] = 'ALL CALCULATED VALES FOR SPHERE WERE OK'
            else:
                kb4xi['reasoned'] = '*** ERRORS IN SPHERE CALCULATIONS***'            
             
        except:
            message2print = "{yielded" + "; kb4xi-yielded-by-reason-of-Ball4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
       
          
        
        message2print = "{reasoned" + "; Ball4Xi-reasoned-by-reason-of-Ball4Xi: " + str(Ball4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-Ball4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-Ball4Xi" usage = "aces Ball4Xi class objects">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        aces Ball4Xi class objects 
        '''
        global id2ball4xi 
                                                                             #Measures
        global ack2sphere                                                    #01 sphere   
        global ack2area                                                      #02 surface area
        global ack2volume                                                    #03 volume 
        global ack2shot                                                      #04 shot  
                                  
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'Ball4Xi'
        method2print = 'ace'
        
                     
        message2print = "{started" + "; ace-of-Ball4Xi-started: "  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
              
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{acing" + "; Ball4Xi-acing-by-ace-of-Ball4Xi: " + str(Ball4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                    
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-Ball4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
            kb8xi ['time-acing-of-Ball4Xi'] = time4xi()
            if ((ack2sphere is True) and (ack2area is True) and (ack2volume is True)):
                kb8xi['aced'] = 'SPHERE TO ACE'
            else:
                kb8xi['aced'] = '*** NO TO BE ACED SPHERE ***'                 
        except:
            message2print = "{yielded" + "; kb8xi-yielded-by-ace-of-Ball4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
              
        message2print = "{aced" + "; Ball4Xi-aced-by-ace-of-Ball4Xi: " + str(Ball4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-Ball4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                  
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_ball4xi.txt
#   sense-test-ball4xi.xml
#   reason-test-ball4xi.xml
#   ace-test-ball4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of ball4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
